//implemetacia triedy ExtendedFATFileSystem

#include "EFATFS.h"
#include <ctype.h>
#include <stack>
#include <iostream>


bool CheckMetaChars(string &s)
{
int h,o; //pocet * a pocet ?
string::iterator it1,it2;

for (h=0,o=0,it1=s.begin(),it2=s.end();it1!=it2;it1++)
	{
	if (*it1=='*')
		h++;
	else if (*it1=='?')
		o++;
	}
if (h)
	return true;
if (o>2)
	return true;
return false;
}


DirEnt::DirEnt(void)
{
}

DirEnt::DirEnt(char *Name, DirectoryEntry *de)
{
this->Name=Name;
this->de=*de;
}

DirEnt::DirEnt(const DirEnt &de)
{
Name=de.Name;
this->de=de.de;
}

DirEnt::~DirEnt(void)
{
}

ExtendedFATFileSystem::ExtendedFATFileSystem(void)
{
}

ExtendedFATFileSystem::~ExtendedFATFileSystem(void)
{
}


bool ExtendedFATFileSystem::GetEFSDir(char *DirName, deque<DirEnt> *DirContent, bool DeletedEntries)
{
int r,n=0,root=0,c;
char zaloha[500], *dir, zaloha2[500];
LongNameCache lnc;
unsigned sclustr;
DirEnt drent;

dir=strcpy(zaloha2,DirName);

DirContent->clear();

fseek(f,RootPos,SEEK_SET);

//vyhladame pozadovany adresar/subor
//odstranime pripadne lomitko na zaciatku
if (strlen(dir)==1 && dir[0]=='\\')
	strcpy(dir,"");
if (strlen(dir)>0)
{
	if (dir[0]=='\\')
	{
		char tmp[200];
		strcpy(tmp,dir+1);
		strcpy(dir,tmp);
	}
	strcpy(zaloha,dir);
	r=FindDirectoryEntry(zaloha);
	if (r==0)
	{
		return false;
	}
	if (r>0)
	{
		if (!(de.sde.Attributes&16))
		{
			return false;
		}
		//vyhladame poziciu 1. clustera podadresara
		//**** prvy cluster je oznaceny ako 2 ***!!!!!
		GoToCluster(sclustr=cnv16bto32(de.sde.StartingCluster,de.sde.ClustHI));
	}
}
else
        {
	root=1;
        if (FAT==FAT32) //root ma vo FAT32 rovnaku strukturu ako kazdy adresar
                {
                root=0;
                GoToCluster(sclustr=fbr.FAT32Ext.RootClus);
                }
        }
lnc.ClearCache();
do
	{
	fread(&de,sizeof(de),1,f);
	n++;
	//dlhe nazvy sa uz spracuju
        lnc.ProcessLongEntry(de);
	if (de.sde.Attributes!=0xf && !(de.sde.Attributes&ATTR_VOLUME_ID) && de.sde.FileName[0]!=0) //mame kratky nazov a vypiseme ho aj s dlhym
	{
		if ((unsigned char)de.sde.FileName[0]!=0xE5 || DeletedEntries)
			{
			if (lnc.Valid)
				drent.Name=lnc.NarrowLongName;
			else
				{
				char tmp[20]="";
				strxncat(tmp,de.sde.FileName,8);
				if (de.sde.Extension[0]!=' ')
					{
					strcat(tmp,".");
					strxncat(tmp,de.sde.Extension,3);
					}
				drent.Name=tmp;
				}
			drent.de=de;
			DirContent->push_back(drent);
			}
	lnc.ClearCache();
	}

	//ak sme precitali cely cluster, prechod na dalsi(ak necitame root)
        //treba zohladnit aj to, ze adresar moze byt plny!
	if (!root && n==DEsPerCluster)
	{
		n=0;
		sclustr=GetFATItem(sclustr);
                if (sclustr>=FATEOCMark())
                        return true;
		GoToCluster(sclustr);
	}
        if (root && n==fbr.MaxRootEntries)
                return true;

	}
while (de.sde.FileName[0]!=0);
return true;
}

void ExtendedFATFileSystem::GenerateFileNameTemplates(deque<string> *Result, string Base, int Num, int ProbM, int ProbA, bool NoMChars)
{
int i,j,k,p,c;
string temp;

randomize();
Result->clear();
for (i=0;i<Num;i++)
	{
	do
		{
		temp=Base;
		while ((j=temp.find('#',0))!=temp.npos)
			{
			//metaznak
			if (random(100)<ProbM)
				{
				c=random(100)<ProbA?'*':'?';
				}
			//pismeno/cislica
			else
				{
				p='A'+random('Z'-'A'+1);
				k='0'+random('9'-'0'+1);
				c=random(2)==1?k:p;
				if (random(2)==1)
					c=tolower(c);
				}
			temp[j]=c;
			}
		}
	while(!NoMChars && !CheckMetaChars(temp));
	Result->push_back(temp);
	}
}

void ExtendedFATFileSystem::GenerateShortFileNameTemplates(deque<string> *Result, int Num)
{
int i,j,k,p,c;
string temp;
deque<string>::iterator i1,i2;

randomize();
Result->clear();
for (i=0;i<Num;i++)
	{
	do
		{
		temp="########.###";
		//zvolime poziciu pre *
		j=random(7);
		temp[j]='*';
		//odstr. 2 nadbytocne #
		do
			k=random(7);
		while (temp[k]=='*');
		temp.erase(k,1);
		do
			k=random(6);
		while (temp[k]=='*');
		temp.erase(k,1);
		
		while ((j=temp.find('#',0))!=temp.npos)
			{
			//metaznak
			if (random(100)<20)
				{
				c='?';
				}
			//pismeno/cislica
			else
				{
				p='A'+random('Z'-'A'+1);
				k='0'+random('9'-'0'+1);
				c=random(2)==1?k:p;
				if (random(2)==1)
					c=tolower(c);
				}
			temp[j]=c;
			}
		//test na zhodu
		k=0;
		for (i1=Result->begin(),i2=Result->end();i1!=i2;i1++)
			if (*i1==temp)
				{
				k=1;
				break;
				}
		}
	while(k);
	Result->push_back(temp);
	}
}

	/*
	funkcia naplni existujucu frontu result(pripadny obsah bude zmazany) menami suborov gener. zo
	sablon vo fronte Templates: z kazdej sablony bude gener. aspon Nmin mien, ale nie viac ako Nmax mien:
	znak * bude v sablone nahradeny 0-10 nah. znakmi/cislicami
	znak ? bude v sablone nahradeny nahodnym znakom/cislicou
	*/

void ExtendedFATFileSystem::GenerateFNamesFromTmplts(deque<string> *Result, deque<string> *Templates, int Nmin, int Nmax, int MaxAstCharCnt)
{
int i,j,k,l,m,a,b,c,p;
string temp;
deque<string>::iterator i1,i2;

randomize();
Result->clear();
for (i=0;i<Templates->size();i++)
	{
	k=random(Nmax-Nmin+1)+Nmin;
	for (j=0;j<k;j++)
		{
		temp=(*Templates)[i];
		while ((p=temp.find('?',0))!=temp.npos) //nahrada znakov ?
			{
			a='A'+random('Z'-'A'+1);
			b='0'+random('9'-'0'+1);
			c=random(2)==1?a:b;
			if (random(2)==1)
				c=tolower(c);
			temp[p]=c;
			}
		while ((p=temp.find('*',0))!=temp.npos) //nahrada znakov *
			{
			temp.erase(p,1); 		//odstranime *
			for (l=0,m=random(MaxAstCharCnt);l<m;l++)
				{
				a='A'+random('Z'-'A'+1);
				b='0'+random('9'-'0'+1);
				c=random(2)==1?a:b;
				if (random(2)==1)
					c=tolower(c);
				temp.insert(p,1,c);
				}
			}
		//test na duplikaty -- ak ret. uz existuje, nevkladame ho
		for(i1=Result->begin(),i2=Result->end(),a=0;i1<i2;i1++)
			if (*i1==temp)
				{
				a=1;
				break;
				}
		if (!a)
			Result->push_back(temp);
		}
	//pridame prazdny retazec na oddelenie mien z jednotl. templ.
	Result->push_back(string(""));
	}
}

int ExtendedFATFileSystem::GenerateRandomFiles(string path, deque<string> *Names, int minsize, int maxsize)
{
FILE *f;
int cnt=0,sz,i;
deque<string>::iterator i1,i2;
string temp;
unsigned char buf[1024];

i1=Names->begin();
i2=Names->end();

for (;i1<i2;i1++)
	{
	temp=*i1;
	if (temp=="")
		continue;
	temp=path+temp;
	if ((f=fopen(temp.c_str(),"wb"))==NULL)
		continue;
	sz=random(maxsize)+minsize;
	while(sz>0)
		{
		for (i=0;i<1024;i++)
			buf[i]=random(256);
		sz-=fwrite(buf,1,sz>=1024?1024:sz,f);
		}
	fclose(f);
	cnt++;
	}
return cnt;
}

void ExtendedFATFileSystem::CreateRandomEFSStructure(deque<FileTemplDesc> *Result, deque<string> *Dirs, deque<string> *Files, deque<int> *Attr, deque<string> *Templates, deque<string> *FileNames, int NumOfDirs, int ProbSubDir, int ProbFlInDir, int ProbAR, int ProbAH, int ProbAS, int ProbAA, bool UseShNames)
{
deque<int> tfref;
deque<string>::iterator i1,i2;
deque<int>::iterator ii1;
deque<DirDesc>::iterator ddi1,ddi2;
deque<FileTemplDesc>::iterator ftdi1, ftdi2;
int i,j;
string s1;
char tmp[500];
DirDesc dd;
FileTemplDesc ftd;


Result->clear();
Dirs->clear();
Files->clear();
Attr->clear();

randomize();

//zistime ktore meno odpoveda ktorej sablone
i1=FileNames->begin();
i=0;
while (i1<FileNames->end())
	{
	if (*i1=="")
		{
		i++;
		i1=FileNames->erase(i1);
		}
	else
		{
		tfref.push_back(i);
		i1++;
		}
	}

//vytvorime adresariky
for (i=0;i<NumOfDirs;i++)
	{
	if (UseShNames)
		sprintf(tmp,"Dir%03d",i);
	else		
		sprintf(tmp,"Directory%05d",i);

	//vnorenie
	if (random(100)<ProbSubDir && (j=Dirs->size())>0)
		{
		j=random(j);
		Dirs->push_back((*Dirs)[j]+"\\"+string(tmp));
		}
	else
		Dirs->push_back(tmp);
	tmp[0]='\0';
	if (random(100)<ProbAR)
		strcat(tmp,"r");
	if (random(100)<ProbAH)
		strcat(tmp,"h");
	if (random(100)<ProbAS)
		strcat(tmp,"s");
	if (random(100)<ProbAA)
		strcat(tmp,"a");
	Attr->push_back(TranslateAttributes(tmp));
	}

//inicializujeme sialene vystupne struktury popisujuce pouzitie sablon
//pre kazdu sablonu zapiseme vsetky adresare
for (i1=Dirs->begin(), i2=Dirs->end();i1<i2;i1++)
	{
	dd.DirName=*i1;
	ftd.Dirs_q.push_back(dd);
	}
//doplnime root(posledny, index bude Dirs->size())
dd.DirName="";
ftd.Dirs_q.push_back(dd);

//toto teraz priradime kazdej sablone
for (i1=Templates->begin(), i2=Templates->end();i1<i2;i1++)
	{
	ftd.Template=*i1;
	Result->push_back(ftd);
	}

//subory
for (i1=FileNames->begin(), i2=FileNames->end(), ii1=tfref.begin();i1<i2;i1++, ii1++)
	{
	s1="";
	//zvolime adresar
	if (random(100)<ProbFlInDir)
		s1=(*Dirs)[((i=random(NumOfDirs)))]+"\\";
	else
		//root - index adresara bude (pozri vyssie)
		i=Dirs->size();
	s1+=*i1; //meno suboru aj s cestou
	Files->push_back(s1);

	//generovanie atributov pre subor
	tmp[0]='\0';
	if (random(100)<ProbAR)
		strcat(tmp,"r");
	if (random(100)<ProbAH)
		strcat(tmp,"h");
	if (random(100)<ProbAS)
		strcat(tmp,"s");
	if (random(100)<ProbAA)
		strcat(tmp,"a");
	Attr->push_back(TranslateAttributes(tmp));

	//zaevidovanie pouzitej sablony a adresara (i index adresara, j index sablony - vytiahnuty zo zoznamu tfref)
	j=*ii1;
	((*Result)[(j)]).Dirs_q[i].Files_q.push_back(*i1);
	}
//teraz ked to uz mame takto pekne urobene, musime zo sablon odstranit prazdne adresare
for (ftdi1=Result->begin(), ftdi2=Result->end();ftdi1<ftdi2; ftdi1++)
	{
	ftd=*ftdi1;
	//toto sa bude dynamicky zmensovat - nemozno pouzit stat. iteratory(aspon si myslim, ze nie)
	for (ddi1=ftd.Dirs_q.begin();ddi1<ftd.Dirs_q.end();)
		{
		if (ddi1->Files_q.size()==0)
			ddi1=ftd.Dirs_q.erase(ddi1);
		else
			ddi1++;
		}
	*ftdi1=ftd;
	}
}

bool ExtendedFATFileSystem::FillEFS(string path, deque<string> *Files, deque<string> *FileNames, deque<string> *Dirs, deque<int> *Attr, bool FragmentFiles, bool UseShNames)
{
deque<string>::iterator si1, si2, si3;
deque<int>::iterator ii1;
string temp;

if (path[path.size()-1]!='/')
	path+='/';

if (!InitSucc)
	return false;

for (si1=Dirs->begin(), si2=Dirs->end(), ii1=Attr->begin(); si1<si2; si1++, ii1++)
	{
	CrtDirectory((char*)si1->c_str(),UseShNames?false:true);
	SetAttributes((char*)si1->c_str(),(unsigned)(*ii1));
	}

for (si1=Files->begin(), si2=Files->end(), si3=FileNames->begin(); si1<si2; si1++, ii1++, si3++)
	{
	temp=path+*si3;
	InsertFile((char*)temp.c_str(),(char*)si1->c_str(),UseShNames?false:true,FragmentFiles);
	SetAttributes((char*)si1->c_str(),(unsigned)(*ii1));
	}
return true;
}

void ExtendedFATFileSystem::GetAllEFSDirs(deque<DirDescr> *Result)
{
stack<string> dirs;
deque<DirEnt> dircontent;
deque<DirEnt>::iterator i1,i2;
string s1;
DirDescr dd;
DirEnt de;

Result->clear();
dirs.push("");
while (!dirs.empty())
	{
	s1=dirs.top();
	dirs.pop();
	dircontent.clear();
	if (GetEFSDir((char*)s1.c_str(),&dircontent,true))
		{
		//vyextraktujeme adresare
		for (i1=dircontent.begin(), i2=dircontent.end();i1<i2;i1++)
			{
			de=*i1;
			if (de.de.sde.Attributes&ATTR_DIRECTORY && (unsigned char)de.de.sde.FileName[0]!=0xE5 && de.de.sde.FileName[0]!='.')
				{
				//zaradime do zasobnika
				dirs.push(s1.empty()?s1+de.Name:s1+"\\"+de.Name);
				}
			}
		dd.DirName=s1;
		dd.DirEntries=dircontent;
		Result->push_back(dd);
		}
	}
}

