#include "LogSystem.h"
#include <deque>
#include "fatlib.h"
#include "EFATFS.h"


LogSystem::LogSystem(void)
{
f=NULL;
PREmode=false;
}

LogSystem::~LogSystem(void)
{
CloseLog();
}

bool LogSystem::InitLog(string FileName, LogType Type, string Title)
{
char tmp[500];
time_t t;
tm bt;

t=time(NULL);
localtime_r(&t,&bt);
sprintf(tmp,"%d. %d. %d %02d:%02d:%02d",bt.tm_mday,bt.tm_mon+1,bt.tm_year+1900,bt.tm_hour,bt.tm_min,bt.tm_sec);

if (f!=NULL)
	return false;
if ((f=fopen(FileName.c_str(),"w"))==NULL)
	return false;
type=Type;

if (Title=="")
	Title="LOG";
if (type==LTHTML)
	{
	fprintf(f,"<HTML>\n<HEAD>\n<TITLE>\n%s\n</TITLE>\n</HEAD>\n",Title.c_str());
	fprintf(f,"<BODY>\n<CENTER><FONT SIZE=+2><B>%s</B></CENTER></FONT><BR>\n",Title.c_str());
	fprintf(f,"<CENTER><FONT SIZE=+1><B>%s</B></CENTER></FONT><BR><BR>\n",tmp);
	}
else
	{
	fprintf(f,"%s\n%s\n\n",Title.c_str(),tmp);
	}
return true;
}

void LogSystem::CloseLog(void)
{
if (f==NULL)
	return;
if (type==LTHTML)
	fprintf(f,"</BODY>\n</HTML>\n");
fclose(f);
f=NULL;
PREmode=false;
}

void LogSystem::LineToLog(string Msg, LineType tt, string Color, string Size)
{
string pre="", post="", temp="";

if (f==NULL)
	return;
if (type==LTHTML)
	{
	if (tt==LnTPRE && !PREmode)
		{
		pre+="<PRE>";
		PREmode=true;
		}
	if (tt!=LnTPRE && PREmode)
		{
		post+="</PRE>";
		PREmode=false;
		}
	if (tt==LnTTT)
		{
		pre+="<TT>";
		post+="</TT>";
		}
	if (Color!="")
		temp="COLOR="+Color+" ";
	if (Size!="")
		temp+="SIZE="+Size;
	if (temp.size()>0)
		{
		pre+="<FONT "+temp+">";
		post+="</FONT>";
		}
	if (!PREmode)
		post+="<BR>";
	Msg=pre+Msg+post;
	}
fprintf(f,"%s\n",Msg.c_str());
}

void LogSystem::EFSContentToLog(deque<DirDescr> *EFSContent)
{
DirDescr dd;
DirEnt dre;
DirectoryEntry de;
deque<DirDescr>::iterator ddi1, ddi2;
deque<DirEnt>::iterator dei1, dei2;
char temp[300], c;
unsigned den, mes, rok, hod, min, sec;
string color;

if (!f)
	return;
for (ddi1=EFSContent->begin(), ddi2=EFSContent->end();ddi1<ddi2;ddi1++)
	{
	dd=*ddi1;
	//meno adresara fialovou???
	LineToLog(dd.DirName.size()?dd.DirName:"(ROOT)",LnTTT,"AA00AA");
	for (dei1=dd.DirEntries.begin(), dei2=dd.DirEntries.end();dei1<dei2;dei1++)
		{
		dre=*dei1;
		de=dre.de;
		UnFATDEDate(de.sde.WrtDate, &den, &mes, &rok);
		UnFATDETime(de.sde.WrtTime, &hod, &min, &sec);
		//formatovanie vystupu
		color="";
		if (de.sde.Attributes&ATTR_DIRECTORY)
			{
			c='*';
			color="00BB00";
			}
		else
			c=' ';
		if ((unsigned char)de.sde.FileName[0]==0xE5)
			{
			de.sde.FileName[0]='?';
			dre.Name[0]='?';
			color="CC0000";
			}
		sprintf(temp,"%c%8.8s.%3.3s %c%c%c%c %8u %2u.%2u.%4u %02u:%02u:%02u %u %s",c,de.sde.FileName, de.sde.Extension, de.sde.Attributes&ATTR_READ_ONLY?'r':'-', de.sde.Attributes&ATTR_HIDDEN?'h':'-', de.sde.Attributes&ATTR_SYSTEM?'s':'-', de.sde.Attributes&ATTR_ARCHIVE?'a':'-', de.sde.FileSize, den, mes, rok, hod, min, sec, cnv16bto32(de.sde.StartingCluster,de.sde.ClustHI), dre.Name.c_str());
		LineToLog(temp,LnTPRE,color);
		}
	LineToLog();
	}
}

