#include "fatlib.h"
#include "EFATFS.h"
#include "LogSystem.h"
#include <deque>
#include <iostream>
#include <string>

//generuje unik. mah. c., pouzit max. 100 krat
int UniqRandom(int l)
{
static int mem[100];
static bool init=false;
static int indx=0;
int i,k;
bool u=false;

if (indx>=100)
	{
	u=false;
	indx=0;
	}
if (!init)
	{
	for (i=0;i<100;i++)
		mem[i]=-1;
	init=true;
	}
while (!u)
	{
	k=random(l);
	u=true;
	for (i=0;i<100;i++)
		if (k==mem[i])
			u=false;
	}
mem[indx++]=k;
return k;
}

using namespace std;
main(int argc, char ** argv )
{
ExtendedFATFileSystem efs;
deque<string> templates, fnames, gdirs, gfiles, used_fnames;
deque<FileTemplDesc> EFSResult;
deque<int> gattrs;
deque<DirDescr> wholefs;
string s,s1;
LogSystem log;
int i,j,k,l,m;
FILE *f1,*f2, *f3;
char sss[500];
FileTemplDesc ftd;
DirDesc dd;
deque<string>::iterator ii1,ii2;
int r_time=30;
bool chrt=false;
char rparams[500]="";

if ((f1=fopen("time_cfg","r"))!=NULL)
	{
	fscanf(f1,"%d %s",&r_time,sss);
	if (!fgets(rparams,500,f1)) //ine pomocne parametre pre runner
		rparams[0]='\0';
	else
		rparams[strlen(rparams)-1]='\0';
	fclose(f1);
	if (strcmp(sss,"chroot")==0)
		chrt=true;
	}

log.InitLog("EFSprep_log.html",LTHTML,"Priprava pracovneho EFS");
log.LineToLog();
log.LineToLog("Zapis suborov z emulovaneho FS do realneho - FAT16",LnTStd,"","+1");
if (!efs.CreateEmptyFileSystem("FATwork.f16",20000000,FAT16,2))
	{
	log.LineToLog("Vytvorenie prazdneho EFS: FAILED",LnTStd,"FF0000");
	exit(1);
	}
log.LineToLog("Vytvorenie prazdneho EFS: OK",LnTStd,"00EE00");
system("mkdir temp");

efs.GenerateFileNameTemplates(&templates,"##########.###",5,20,80);
efs.GenerateFNamesFromTmplts(&fnames,&templates,45,50);

log.LineToLog();
log.LineToLog("Sablony mien a vygenerovane mena suborov pouzite na naplnenie pracovneho EFS:",LnTStd,"","+1");
for (i=0,j=0;i<templates.size();i++)
	{
	log.LineToLog(templates[i],LnTPRE,"FUCHSIA");
	while (fnames[j]!="")
		{
		log.LineToLog(fnames[j],LnTPRE);
		j++;
		}
	j++;
	log.LineToLog();
	}

efs.GenerateRandomFiles("temp/",&fnames,0,75000);
efs.CreateRandomEFSStructure(&EFSResult, &gdirs, &gfiles, &gattrs, &templates, &fnames, 12, 75, 90, 20, 20, 20, 50);
if (!efs.Init("FATwork.f16",FAT16,true))
	exit(1);
efs.FillEFS("temp",&gfiles,&fnames,&gdirs,&gattrs);
system("rm -r -f temp");
log.LineToLog();
efs.GetAllEFSDirs(&wholefs);
log.LineToLog("Obsah pracovneho EFS:",LnTStd,"","+1");
log.EFSContentToLog(&wholefs);
efs.Close();

log.LineToLog();
log.LineToLog();
log.LineToLog("Planovane spustenie zadania:",LnTStd,"","+1");

//vyber adresarov a sablon z EFS na prepis do Rfs
system("mkdir work");

//vyberieme 3 sablony
//ku kazdej z nich 2 adresare
f1=fopen("_to_check","w");
f2=fopen("_to_run","w");
f3=fopen("_to_check_2","w");
fprintf(f2,"#!/bin/bash\n");
fprintf(f2,"spcb=`du -s -b | tr -d \"[:blank:]|.\"`\n");
randomize();
used_fnames.clear();
for (i=0;i<3;i++)
	{
	j=UniqRandom(EFSResult.size());
	ftd=EFSResult[j];
	//2 adresare
	s1="";
	for (k=0;k<2;k++)
		{
		l=random(ftd.Dirs_q.size());
		dd=ftd.Dirs_q[l];
		s=dd.DirName;

		//pokus o neopakovanie adresarov
		if (s1.empty())
			s1=s;
		else
			if (s1==s)
				{
				l=random(ftd.Dirs_q.size());
				dd=ftd.Dirs_q[l];
				s=dd.DirName;
				}

		if (!s.empty())
			s+="/";
		s+=ftd.Template;
		//musime nahradit spatne lom. norm.
		while ((l=s.find("\\"))!=s.npos)
			s[l]='/';


		//ak bol zadany parameter pred runner sa pripoji cesta k nemu
		if (!chrt)
			{
			fprintf(f2,"%srunner -r zadanie_%d%d.out zadanie_%d%d.err %s %d zadanie FATwork.f16 \"%s\" work\n",argc>1?argv[1]:"",i,k,i,k,rparams,r_time,s.c_str());
			fprintf(f2,"spc=`du -s -b | tr -d \"[:blank:]|.\"`\n");
			}
		else
			{
			fprintf(f2,"sudo /usr/sbin/chroot `pwd` %srunner -r zadanie_%d%d.out zadanie_%d%d.err %s %d zadanie FATwork.f16 \"%s\" work\n",argc>1?argv[1]:"",i,k,i,k,rparams,r_time,s.c_str());
			fprintf(f2,"spc=`sudo /usr/sbin/chroot \\`pwd\\` du -s -b | tr -d \"[:blank:]|.\"`\n");
			}
		fprintf(f2,"if (($spc - $spcb > 10000000))\n");
		fprintf(f2,"\tthen\n");
    		fprintf(f2,"\texit 1\n");
		fprintf(f2,"fi\n");
		sprintf(sss,"Presmerovanie vystupu:zadanie_%d%d.out\nPresmerovanie chyboveho vystupu: zadanie_%d%d.err",i,k,i,k);
		log.LineToLog(string("zadanie FATwork.f16 \""+s+"\" work"),LnTPRE);
		log.LineToLog(sss,LnTPRE,"FUCHSIA");
		//musime najst zodp. subory
		for (ii1=dd.Files_q.begin(),ii2=dd.Files_q.end();ii1<ii2;ii1++)
			{
			fprintf(f1,"%s\n",(dd.DirName+"\\"+*ii1).c_str());
			used_fnames.push_back(*ii1);
			}
		}
	}
fprintf(f2,"exit 0\n");
fclose(f1);
fclose(f2);
//fo f3 zapiseme subory, ktore vo worku nemaju byt!
for (ii1=fnames.begin(),ii2=fnames.end();ii1<ii2;ii1++)
	{
	j=0;
	if (*ii1=="")
		continue;
	for (i=0;i<used_fnames.size();i++)
		if (used_fnames[i]==*ii1)
			{
			j=1;
			break;
			}
	if (!j)
		fprintf(f3,"%s\n",ii1->c_str());
	}
fclose(f3);
log.CloseLog();
}
