#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdlib.h>
#include <wchar.h>


#include "fatlib.h"
#include "xcompat.h"

// praca s cestami
//odstrani zaciatocne/konecne spatne lomitka
char* RemoveSlashes(char *ret)
{
int i;
while (*ret=='\\')
        for (i=1;i<=strlen(ret);i++)
                ret[i-1]=ret[i];

while (ret[strlen(ret)-1]=='\\')
        ret[strlen(ret)-1]='\0';
return ret;
}
//vrati pocet casti cesty oodel. spat. lomitkom
unsigned NumberOfFilePathElements (char *ret)
{
int i=1;
while (ret=strchr(ret,'\\'))
        {
        ret++;
        i++;
        }
return i;
}
//vrati pozad.casti cesty
void GetPathElements(char *ret,char *dest,unsigned firstE, unsigned lastE)
{
int i=NumberOfFilePathElements(ret);
if (firstE>i || lastE>i)
        {
        dest[0]='\0';
        return;
        }
for (i=1;i<firstE;i++)
        ret=strchr(ret,'\\')+1;
strcpy(dest,ret);
lastE-=firstE-1;
for (i=0;i<lastE;i++,dest++)
        {
        dest=strchr(dest,'\\');
        if (dest==NULL)
                break;
        }
if (dest!=NULL)
        *(dest-1)='\0';
}

unsigned short FATDEDate(unsigned short d, unsigned short m,unsigned short r)
{
unsigned short result=0;
r-=1980;
result=r<<9;
result|=m<<5;
result|=d;
return result;
}

void UnFATDEDate(unsigned short DEDate, unsigned *d, unsigned *m, unsigned *r)
{
*d=DEDate&(0x1F);
*m=(DEDate&(0x1E0))>>5;
*r=(DEDate&(0xFE00))>>9;
*r=*r+1980;
}


void UnFATDETime(unsigned short DETime, unsigned *h, unsigned *m, unsigned *s)
{
*s=DETime&0x1F;
*m=(DETime&0x7E0)>>5;
*h=(DETime&0xF800)>>11;
}



unsigned short FATDEDate(void)
{
time_t mytime;
tm broken_time;
mytime=time(NULL);
localtime_r(&mytime,&broken_time);
return FATDEDate(broken_time.tm_mday, broken_time.tm_mon+1, broken_time.tm_year+1900);
}

unsigned short FATDETime(unsigned short h, unsigned short m,unsigned short s)
{
unsigned short result=0;
result=h<<11;
result|=m<<5;
result|=s/2;
return result;
}

unsigned short FATDETime(void)
{
time_t mytime;
tm broken_time;
mytime=time(NULL);
localtime_r(&mytime,&broken_time);
return FATDETime(broken_time.tm_hour, broken_time.tm_min, broken_time.tm_sec);
}

void cnv32bto16(unsigned Src, unsigned short *LoWord, unsigned short *HiWord)
{
*LoWord=Src&0xFFFF;
*HiWord=(Src&0xFFFF0000)>>16;
}

unsigned cnv16bto32(unsigned short LoWord, unsigned short HiWord)
{
return (HiWord<<16)|LoWord;
}


//funkcia spoji dva retazce, max n znakov, ukonci sa pri vyskyte medzery
void strxncat(char *rdest,char *rsrc,int n)
{
int i=0;
while (*rdest)
	rdest++;
while (*rsrc && *rsrc!=' ' && i<n)
{
	*rdest=*rsrc;
	i++;
	rdest++;
	rsrc++;
}
*rdest='\0';
}

//implementacia triedy FATFileSystem

FATFileSystem::FATFileSystem(void)
{
        InitSucc=0;
        FATBuffering=false;
        FATBuf=new char[131072];

}

FATFileSystem::~FATFileSystem(void)
{
	if (InitSucc)
                {
                if (FATBuffering)
                        WriteFATBuffer();
		fclose(f);
                }
        if (FATBuf!=NULL)
                delete FATBuf;
}

void FATFileSystem::Close(void)
{
if (InitSucc)
	{
	if (FATBuffering)
		WriteFATBuffer();
	fclose(f);
	}
        InitSucc=0;
        FATBuffering=false;
}


int FATFileSystem::ReadBootRecord(char *filename)
{
if ((f=fopen(filename,"rb+"))==NULL)
	return 0;


if (FAT==FAT12 || FAT==FAT16)
        {
        fread(&fbr,FATBootRecordSize,1,f);
        RootPos=(fbr.ReservedSectors+fbr.SectorsPerFAT*fbr.NumberOfFATs)*fbr.BytesPerSector;
        SystemSectors=fbr.ReservedSectors+fbr.SectorsPerFAT*fbr.NumberOfFATs+(fbr.MaxRootEntries*sizeof(DirectoryEntry))/fbr.BytesPerSector;
        FirstDataSector=SystemSectors;
        FATImageName=filename;
        FirstFATSector=fbr.ReservedSectors;
        DEsPerCluster=(fbr.BytesPerSector*fbr.SectorsPerCluster)/sizeof(DirectoryEntry);
        return 1;
        }

if (FAT==FAT32)
        {
        fread(&fbr,FATBootRecordSize,1,f);
        SystemSectors=fbr.ReservedSectors+fbr.FAT32Ext.FATSz32*fbr.NumberOfFATs+(fbr.MaxRootEntries*sizeof(DirectoryEntry))/fbr.BytesPerSector;
        FirstDataSector=SystemSectors;
        RootPos=(fbr.SectorsPerCluster*((fbr.FAT32Ext.RootClus)-2)+SystemSectors)*fbr.BytesPerSector;
        FATImageName=filename;
        FirstFATSector=fbr.ReservedSectors;
        DEsPerCluster=(fbr.BytesPerSector*fbr.SectorsPerCluster)/sizeof(DirectoryEntry);
        return 1;
        }


return 0;
}

int FATFileSystem::Init(char *fatimagename,FATType type, bool FATBuff)
{
unsigned clusters;

        FAT=type;
	InitSucc=ReadBootRecord(fatimagename);
        FATBuffering=FATBuff;

	if (!InitSucc)
		return 0;

	LastAllocatedCluster=0;

        //spocitame pocet clustrov
        clusters=fbr.NumberOfSectors==0?fbr.BigNumberOfSectors:fbr.NumberOfSectors;
        clusters=(clusters-FirstDataSector)/fbr.SectorsPerCluster;
        NumberOfClusters=clusters;

        if (InitSucc && FATBuff)
                //inicializujeme buffer pre FAT
                InitFATBuffer();
        return InitSucc;
}


//zrusim vypis do stlpcov a pridam dlhe mena - TATO FUNKCIA ZOHLADNUJE DLHE MENA!!!!!!!*****
int FATFileSystem::PrintDir(char *dir)
{
int r,n=0,root=0,c;
char zaloha[500];
LongNameCache lnc;
unsigned sclustr, lines=0; //pocitadlo lines sluzi na zistenie, kolko riadkov sme uz vypisali
				//tu nie je wherey()

clrscr();

fseek(f,RootPos,SEEK_SET);

//vyhladame pozadovany adresar/subor
//odstranime pripadne lomitko na zaciatku
if (strlen(dir)==1 && dir[0]=='\\')
	strcpy(dir,"");
if (strlen(dir)>0)
{
	if (dir[0]=='\\')
	{
		char tmp[200];
		strcpy(tmp,dir+1);
		strcpy(dir,tmp);
	}
	strcpy(zaloha,dir);
	printf("%s",zaloha);
	r=FindDirectoryEntry(zaloha);
	if (r==0)
	{
		printf(" Hladana polozka neexistuje\n");
		return 0;
	}
	if (r>0)
	{
		printf("je %s\n",de.sde.Attributes&16?"Adresar":"Subor");
		if (!(de.sde.Attributes&16))
		{
			return 0;
		}
		//vyhladame poziciu 1. clustera podadresara
		//**** prvy cluster je oznaceny ako 2 ***!!!!!
		GoToCluster(sclustr=cnv16bto32(de.sde.StartingCluster,de.sde.ClustHI));
	}
}
else
        {
	root=1;
        if (FAT==FAT32) //root ma vo FAT32 rovnaku strukturu ako kazdy adresar
                {
                root=0;
                GoToCluster(sclustr=fbr.FAT32Ext.RootClus);
                }
        }
lnc.ClearCache();
do
	{
	fread(&de,sizeof(de),1,f);
	n++;
	//dlhe nazvy sa uz spracuju
        lnc.ProcessLongEntry(de);
	if (de.sde.Attributes!=0xf && de.sde.FileName[0]!=0) //mame kratky nazov a vypiseme ho aj s dlhym
	{
		//ak je polozka adresarom, predpiseme *, ak je zmazana - #
		c=' ';
		if (de.sde.Attributes&16)
			c='*';
		if ((unsigned char)de.sde.FileName[0]==0xe5)
		{
			de.sde.FileName[0]='?';
			c='#';
		}
		printf("%c%8.8s.%3.3s %s\n\r",c,de.sde.FileName,de.sde.Extension,lnc.Valid?lnc.NarrowLongName:"");
		lines++;
                lnc.ClearCache();
	}
	if (lines==24)
		{
                printf("Enter ...");
                getchar();
                clrscr();
		lines=0;
                }

	//ak sme precitali cely cluster, prechod na dalsi(ak necitame root)
        //treba zohladnit aj to, ze adresar moze byt plny!
	if (!root && n==DEsPerCluster)
	{
		n=0;
		sclustr=GetFATItem(sclustr);
                if (sclustr>=FATEOCMark())
                        return 1;
		GoToCluster(sclustr);
	}
        if (root && n==fbr.MaxRootEntries)
                return 1;

	}
while (de.sde.FileName[0]!=0);
return 1;
}


//**************** TATO FUNKCIA UZ TIEZ ZOHLADNUJE DLHE MENA !!!!!!!!!!!!!!!!!!!!!!!!!***
long FATFileSystem::FindDirectoryEntry(char *name, long* DESoffsets)
{
char ret[200]="",*p,fname[500],zaloha[1000];
int root=1,n,found=0, off_indx=0;
LongNameCache lnc;
unsigned clstr;

strcpy(zaloha,name);
name=zaloha;

if (DESoffsets!=NULL)
	memset(DESoffsets,0,sizeof(long)*20);

//odstranime pripadne \ na konci cesty/suboru
if (name[strlen(name)-1]=='\\')
	name[strlen(name)-1]='\0';

//nastavime sa na ROOT
fseek(f,RootPos,SEEK_SET);
if (FAT==FAT32) //root ma vo FAT32 rovnaku strukturu ako kazdy adresar
        {
        root=0;
        GoToCluster(clstr=fbr.FAT32Ext.RootClus);
        }


while (strlen(name)>0)
{
	//nastavime sa na prvy cluster posledne najdenej polozky(ak ex. a je adresarom)
	//bit udavajuci adresar je stvrty od konca (pocitane od nuly)
	if (strlen(ret)>0) //obsahuje posledne najdenu polozku
		if (de.sde.Attributes&16) //je to adresar
			//**** prvy cluster je oznaceny ako 2 ***!!!!!
			{
			GoToCluster(clstr=cnv16bto32(de.sde.StartingCluster,de.sde.ClustHI));
			root=0;
			}
		else
			return 0;

	//ziskame nasledujucu polozku cesty
	p=strchr(name,'\\');
	if (p!=NULL)
	{
		*p='\0';
		strcpy(ret,name);
		name=p+1;
	}
	else
	{
		strcpy(ret,name);
		*name='\0';
	}

	//vyhladame polozku v adresari
	n=0;
        lnc.ClearCache();
	if (DESoffsets!=NULL)
		memset(DESoffsets,0,sizeof(long)*20);
	off_indx=0;

	do
	{
		fread(&de,sizeof(DirectoryEntry),1,f);
		n++;
		lnc.ProcessLongEntry(de);
		//poskladame meno a priponu - retazce NIE SU ukoncene \0
		fname[0]='\0';
		strxncat(fname,de.sde.FileName,8);
		if (de.sde.Extension[0]!=' ')
			{
			strcat(fname,".");
			strxncat(fname,de.sde.Extension,3);
			}
                //najprv porovname LONG NAME (ak je kompletne) a potom short
                if (lnc.Valid && lnc.Last && lnc.First && lnc.Checksummed)
                        {
                        found=!strcasecmp(lnc.NarrowLongName,ret);
                        lnc.ClearCache();
                        }
		if (!found)
                        found=!strcasecmp(fname,ret);

		//teraz sa treba postarat o ulozenie offsetu najedej DE
		if (DESoffsets!=NULL)
			{
			//ak je to dlhe meno -- zapamatame offset
			if (((de.lde.LDIR_Attr & ATTR_LONG_NAME_MASK)==ATTR_LONG_NAME) && (de.lde.LDIR_Ord!=0xE5))
				DESoffsets[off_indx++]=ftell(f)-32;
			else
			//nasli sme volume ID alebo zmazanu polozku - zmazeme offsety
			if ((de.lde.LDIR_Attr & ATTR_VOLUME_ID) || (de.lde.LDIR_Ord==0xE5))
				{
				memset(DESoffsets,0,sizeof(long)*20);
				off_indx=0;
				}
			else
			//nasli sme SDE -- ak sme nasli hladanu polozku, zapamatame offset
			//ak nie, zmazeme offsety
			if (found)
				DESoffsets[off_indx++]=ftell(f)-32;
			else
				{
				memset(DESoffsets,0,sizeof(long)*20);
				off_indx=0;
				}
			}

		//prechod na dalsi cluster
		if (!root && n==DEsPerCluster && !found) //inak by to skocilo na zly offset
		{
			clstr=GetFATItem(clstr);
                        if (clstr>=FATEOCMark())
                                return 0;
			GoToCluster(clstr);
			n=0;
		}
	}
	while (de.sde.FileName[0]!='\0' && !found);

	//polozku sa nepodarilo najst
	if (!found)
		return 0;
        found=0;
}
//nastavenie offsetu
return ftell(f)-sizeof(DirectoryEntry);
}

void FATFileSystem::PrintInfo(void)
{
printf("%s\n",FATImageName);
printf("OEM:%8.8s\n",fbr.OEMNameString);
printf("Bytes/Sector:%u\n",fbr.BytesPerSector);
printf("Sectors/Cluster:%u\n",fbr.SectorsPerCluster);
printf("Reserved Sectors:%u\n",fbr.ReservedSectors);
printf("Sectors/FAT:%u\n",fbr.SectorsPerFAT);
printf("FATs:%u\n",fbr.NumberOfFATs);
printf("Max. Root Entries:%u\n",fbr.MaxRootEntries);
printf("Total Sectors(small):%u\n",fbr.NumberOfSectors);
printf("Total Sectors(Big):%lu\n",fbr.BigNumberOfSectors);
printf("Heads:%u\n",fbr.NumberOfHeads);
printf("Hidden Sectors.:%lu\n",fbr.NumberOfHiddenSectors);
printf("Volume Label:%11.11s\n",FAT==FAT32?fbr.FAT32BPB.Label:fbr.FAT16BPB.Label);
printf("FileSystem ID:%8.8s\n",FAT==FAT32?fbr.FAT32BPB.FileSystemID:fbr.FAT16BPB.FileSystemID);
printf("Serial Number:%lX\n",FAT==FAT32?fbr.FAT32BPB.SerialNumber:fbr.FAT16BPB.SerialNumber);

if (FAT==FAT32)
        {
        printf("\nFAT32 Extended information:\n");
        printf("Sectors/FAT (32) %u\n",fbr.FAT32Ext.FATSz32);
        printf("Flags:%hu\n",fbr.FAT32Ext.ExtFlags);
        printf("File System Version:%hu\n",fbr.FAT32Ext.FSVer);
        printf("Root cluster:%u\n",fbr.FAT32Ext.RootClus);
        printf("FSInfo Sector:%hu\n",fbr.FAT32Ext.FSInfo);
        printf("Backup Boot Sector:%hu\n",fbr.FAT32Ext.BkBootSec);
        }

}

unsigned FATFileSystem::GetFATItem(unsigned n)
{
// NOVY KOD
unsigned offset,result;
unsigned char data[2]; //16-bit
unsigned short res16;

if (FAT==FAT12)
        {
        offset=n+n/2;
        result=0;
        if (FATBuffering)
                memcpy(data,FATBuf+offset,2);
        else
                {
                fseek(f,FirstFATSector*fbr.BytesPerSector+offset,SEEK_SET);
                fread(data,1,2,f);
                }
        if (n%2==0)
                {
                result=(data[1]&0xF)<<8;
                result|=data[0];
                }
        else
                {
                result=(data[1])<<4;
                result|=(data[0]&0xF0)>>4;
                }
        return result;
        }
if (FAT==FAT16)
        {
        result=0;
        if (FATBuffering)
                memcpy(&res16,FATBuf+n*2,2);
        else
                {
                fseek(f,FirstFATSector*fbr.BytesPerSector+n*2,SEEK_SET);
                fread(&res16,2,1,f);
                }

        result=res16;
        return result;
        }

if (FAT==FAT32)
        {
        result=0;

        if (FATBuffering)
                {
                //zistime, ci je dana polozka v bufri
                if ((n>(FirstBufItem+NumItems-1)) || n<FirstBufItem)
                        MoveFATBuffer(n);
                memcpy(&result,FATBuf+((n-FirstBufItem)*4),4);
                }
        else
                {
                fseek(f,FirstFATSector*fbr.BytesPerSector+n*4,SEEK_SET);
                fread(&result,4,1,f);
                }
        return result;
        }

return 0;
}

void FATFileSystem::SetFATItem(unsigned n,unsigned  value)
{
//kazda polozka vo FAT-ke ma 12 bitov alebo 1.5 bajtu
//v 3 bajtoch su ulozene 2 12-bitove hodnoty nasled. sposobom:
//1. hodnota - bity 0-3 2. bajtu, potom 1.bajt
//2. hodnota - 3. bajt, bity 7-4 2. bajtu
// NOVY KOD
unsigned offset,i;
unsigned char data[2]; //16-bit
unsigned short result16;

if (FAT==FAT12)
        {
        offset=n+n/2;
        if (FATBuffering)
                memcpy(data,FATBuf+offset,2);
        else
                {
                fseek(f,FirstFATSector*fbr.BytesPerSector+offset,SEEK_SET);
                fread(data,1,2,f);
                }

        if (n%2==0)
                {
                data[1]&=0xF0;
                data[1]|=(value>>8);
                data[0]=(value&0xFF);
                }
        else
                {
                data[1]=value>>4;
                data[0]&=0xF;
                data[0]|=(value<<4)&0xF0;
                }
        //zapis do vsetkych FATiek
        if (FATBuffering)
                {
                memcpy(FATBuf+offset,data,2);
                }
        else
                for (i=0;i<fbr.NumberOfFATs;i++)
                        {
                        fseek(f,FirstFATSector*fbr.BytesPerSector+offset+i*fbr.SectorsPerFAT*fbr.BytesPerSector,SEEK_SET);
                        fwrite(data,1,2,f);
                        }
        }
if (FAT==FAT16)
        {
        offset=n*2;
        result16=value;
        if (FATBuffering)
                {
                memcpy(FATBuf+offset,&result16,2);
                }
        else
                for (i=0;i<fbr.NumberOfFATs;i++)
                        {
                        fseek(f,FirstFATSector*fbr.BytesPerSector+offset+i*fbr.SectorsPerFAT*fbr.BytesPerSector,SEEK_SET);
                        fwrite(&result16,2,1,f);
                        }
        }

if (FAT==FAT32)
        {
        offset=n*4;
        if (FATBuffering)
                {
                if (n>FirstBufItem+NumItems-1 || n<FirstBufItem)
                        MoveFATBuffer(n);
                memcpy(FATBuf+(n-FirstBufItem)*4,&value,4);
                }
        else
                for (i=0;i<fbr.NumberOfFATs;i++)
                        {
                        fseek(f,FirstFATSector*fbr.BytesPerSector+offset+i*fbr.FAT32Ext.FATSz32*fbr.BytesPerSector,SEEK_SET);
                        fwrite(&value,4,1,f);
                        }
        }
}

//PODPORUJE DLHE NAZVY
int FATFileSystem::DelFile(char *name)
{
int rv;
long offs[25], off;
unsigned cluster,nextcluster;
char zaloha[1000];

if (strlen(name)==0)
	return 0;

strcpy(zaloha,name);
name=zaloha;

//najdeme DE hladaneho suboru
rv=FindDirectoryEntry(name,offs);

if (!rv)
	return 0; 		//subor neexistuje
//mazanie
//zistime zac. cluster
cluster=cnv16bto32(de.sde.StartingCluster,de.sde.ClustHI);
//zapiseme modifikovany DE - ak ex. dlhe meno zrusime vsetky de
//offsety mame pohodlne v poli
rv=0;
while ((off=offs[rv++])!=0)
        {
        fseek(f,off,SEEK_SET);
        fputc(0xE5,f);
        }
//prehladame FAT-ku a uvolnime obsadene clustre
if (cluster<2)
        return 1; //je to prazdny subor
rv=1;
do
{
	if ((nextcluster=GetFATItem(cluster))>=FATEOCMark()) //posledny cluster suboru
		rv=0;
	//uvolnime cluster a prejdeme na dalsi
	SetFATItem(cluster,0);
	cluster=nextcluster;
}
while(rv);
return 1;
}

void FATFileSystem::GoToCluster(unsigned cl)
{
fseek(f,(fbr.SectorsPerCluster*((cl)-2)+SystemSectors)*fbr.BytesPerSector,SEEK_SET);
}

unsigned FATFileSystem::FreeClusters(void)
{
unsigned i,freeclusters=0,clusters=fbr.NumberOfSectors==0?fbr.BigNumberOfSectors:fbr.NumberOfSectors;
clusters=(clusters-FirstDataSector)/fbr.SectorsPerCluster;

//clustre su cislovane od 2!!!!! - len v MS mohli vymysliet taku sprostost
for (i=2;i<clusters+2;i++)
        if (GetFATItem(i)==0)
                freeclusters++;
return freeclusters;
}

unsigned FATFileSystem::FreeSpace(void)
{
return FreeClusters()*fbr.BytesPerSector*fbr.SectorsPerCluster;
}

unsigned FATFileSystem::GetFreeCluster(bool Fragments)
{
unsigned i,j;

//clustre su cislovane od 2!!!!! - len v MS mohli vymysliet taku sprostost
for (i=(LastAllocatedCluster==0||Fragments)?2:LastAllocatedCluster;i<NumberOfClusters+2;i++)
        if (GetFATItem(i)==0)
                {
                if (!Fragments)
                        return (LastAllocatedCluster=i);
                j=random(NumberOfClusters-i)+i;
                if (GetFATItem(j)==0)
                        return j;
                else
                        return i;
                }
//ak sme nic nenasli a pouzili poslednu poziciu tak ju zrusime a hladame od zaciatku
//trebars aj rekurzivne
if (LastAllocatedCluster!=0)
        {
        LastAllocatedCluster=0;
        return GetFreeCluster(Fragments);
        }
else
        return 0;
}

long FATFileSystem::GetFreeDEPosition(char *path,unsigned long *parentcluster)
{
long off;
int root=0,n=0,i;
bool found=false;
unsigned clus,nclus;
unsigned char c=0;

if (parentcluster!=NULL)
        *parentcluster=0;
if (strlen(path)==0)
        {
        off=RootPos;
        root=1;
        fseek(f,off,SEEK_SET);
        if (FAT==FAT32)
                {
                root=0;
                clus=fbr.FAT32Ext.RootClus;
                }
        }
else
        if (!(off=FindDirectoryEntry(path)))
                return 0;
        else
                {
                fseek(f,off,SEEK_SET);
                fread(&de,sizeof(de),1,f);
                GoToCluster(clus=cnv16bto32(de.sde.StartingCluster,de.sde.ClustHI));
                if (parentcluster!=NULL)
                        *parentcluster=clus;
                }

//po tychto pochybnych operaciach sme snad na clustri spravneho adresara
do
        {
        fread(&de,sizeof(de),1,f);
        n++;
        if (de.sde.FileName[0]==0 || (unsigned char)(de.sde.FileName[0])==0xE5)
                found=true;

        //!!!!!!!!!!!FAT12/16 ONLY
        if (root && n==fbr.MaxRootEntries && !found)
                return 0;
        if (!root && n==DEsPerCluster && !found)
                {
                //teraz treba bud prejst na dalsi cluster adresara alebo ho rozsirit
                nclus=GetFATItem(clus);
                if (nclus<FATEOCMark())
                        {
                        clus=nclus;
                        GoToCluster(clus);
                        n=0;
                        }
                else    //pokus o rozsirenie adresara
                        {
                        if ((nclus=GetFreeCluster())!=0)
                                {
                                SetFATItem(clus,nclus);
                                SetFATItem(nclus,FATEOCMark());
                                GoToCluster(nclus);
                                //vycistenie clustra
                                for (i=0;i<fbr.BytesPerSector*fbr.SectorsPerCluster;i++)
                                        fwrite(&c,1,1,f);
                                GoToCluster(nclus);
                                return ftell(f);
                                }
                        return 0; //rozsirenie sa nepodarilo
                        }
                }


        }
        while (!found);
        return ftell(f)-sizeof(de);
}

long FATFileSystem::GetFreeDEPositions(int DESNeeded, char *path,unsigned long *parentcluster,unsigned long *NumberOfDEPosition,unsigned long *NumberOfCluster,bool *Root)
{
long off,soff;
int root=0,n=0,i;
int found=DESNeeded; //zmena!
unsigned clus,nclus;
unsigned char c=0;
//premenna DESNeeded udava pocet za sebou nasled. volnych DE

if (parentcluster!=NULL)
        *parentcluster=0;
if (strlen(path)==0)
        {
        off=RootPos;
        root=1;
        fseek(f,off,SEEK_SET);
        if (FAT==FAT32)
                {
                root=0;
                clus=fbr.FAT32Ext.RootClus;
                }
        }
else
        if (!(off=FindDirectoryEntry(path)))
                return 0;
        else
                {
                fseek(f,off,SEEK_SET);
                fread(&de,sizeof(de),1,f);
                GoToCluster(clus=cnv16bto32(de.sde.StartingCluster,de.sde.ClustHI));
                if (parentcluster!=NULL)
                        *parentcluster=clus;
                }

//po tychto pochybnych operaciach sme snad na clustri spravneho adresara
if (Root!=NULL)
        *Root=root;
do
        {
        fread(&de,sizeof(de),1,f);
        n++;
        if (de.sde.FileName[0]==0 || (unsigned char)(de.sde.FileName[0])==0xE5)
                {
                if (found==DESNeeded)
                        {
                        soff=ftell(f)-sizeof(de);
                        if (NumberOfDEPosition!=NULL)
                                *NumberOfDEPosition=n-1;
                        if (NumberOfCluster!=NULL)
                                *NumberOfCluster=clus;
                        }
                found--; //nasli sme volnu DE
                }
        else
                found=DESNeeded; //nasli sme obsadenu - musime hladat odznova

        //!!!!!!!!!!!FAT12/16 ONLY
        if (root && n==fbr.MaxRootEntries && found>0)
                return 0;
        if (!root && n==DEsPerCluster && found>0)
                {
                //teraz treba bud prejst na dalsi cluster adresara alebo ho rozsirit
                nclus=GetFATItem(clus);
                if (nclus<FATEOCMark())
                        {
                        clus=nclus;
                        GoToCluster(clus);
                        n=0;
                        }
                else    //pokus o rozsirenie adresara
                        {
                        if ((nclus=GetFreeCluster())!=0)
                                {
                                SetFATItem(clus,nclus);
                                SetFATItem(nclus,FATEOCMark());
                                GoToCluster(clus=nclus);
                                //vycistenie clustra
                                for (i=0;i<fbr.BytesPerSector*fbr.SectorsPerCluster;i++)
                                        fwrite(&c,1,1,f);
                                GoToCluster(nclus);
                                n=0;
                                }
                        else
                                return 0; //rozsirenie sa nepodarilo
                        }
                }


        }
        while (found>0);
        return soff;
}



int FATFileSystem::CrtDirectory(char* path,bool longname)
{
int elems;
long offset;
char path2[300],fname[300],zaloha[1000];
unsigned clus;
unsigned long pclus,n,dclus;
unsigned char c=0;
LongNameCache lnc;
bool root;

strcpy(zaloha,path);
path=zaloha;
RemoveSlashes(path);

if (FindDirectoryEntry(path)!=0)
        return false;

elems=NumberOfFilePathElements(path);
GetPathElements(path,path2,1,elems-1);
if (elems==1)
        strcpy(path2,"");

///////////////// cast pre kratky nazov
if (!longname)
        {
        if ((offset=GetFreeDEPosition(path2,&pclus))==0 || (clus=GetFreeCluster())==0 ) //ak nie je volny cluster aebo sa neda najst/vytvorit volne DE
                return 0;

        //vytvorime de noveho adresara
        memset(&de,0,sizeof(de));
        memset(&de,' ',11);
        if (strrchr(path,'.'))
                return 0;
        GetPathElements(path,path2,elems,elems);
        strupr(path2);
        strcat(path2,"          ");
        strncpy(de.sde.FileName,path2,8);
        fseek(f,offset,SEEK_SET);
        }
//////////////////koniec kratkeho nazvu
else
/////////////////cast pre vytvorenie dlheho nazvu
        {
        GetPathElements(path,fname,elems,elems);
        elems=strlen(fname);
        if ((offset=GetFreeDEPositions(elems%13==0?elems/13+1:elems/13+2, path2,&pclus,&n,&dclus,&root))==0 || (clus=GetFreeCluster())==0 ) //ak nie je volny cluster alebo sa neda najst/vytvorit dost volnych DE, je tu zaratany aj ShortDE
                return 0;
        lnc.ProcessLongName(fname);
        if (!lnc.PrepareToWriteLongName(path,fname,this)) //neda sa vytvorit alias
                return 0;

        //zapiseme casti dlheho nazvu
        fseek(f,offset,SEEK_SET);
        do
                {
                elems=lnc.CreateLDE(&de);
                fwrite(&de,sizeof(de),1,f);
                n++;
                if (!root && n==DEsPerCluster)
                        {
                        n=0;
                        dclus=GetFATItem(dclus);
                        GoToCluster(dclus);
                        }
                }
        while (elems>1); //1 je posledna v poradi
        memcpy(&de,fname,11); // - short alias
        }
/////////////////koniec casti pre vytvorenie dlheho nazvu

de.sde.Attributes=0x10;
de.sde.WrtTime=FATDETime();
de.sde.WrtDate=FATDEDate();
de.sde.CrtTime=de.sde.WrtTime;
de.sde.CrtDate=de.sde.WrtDate;
de.sde.CrtTimeTenth=0;
de.sde.LstAccDate=de.sde.CrtDate;
cnv32bto16(clus,&de.sde.StartingCluster,&de.sde.ClustHI);
de.sde.FileSize=0;

fwrite(&de,sizeof(de),1,f);
SetFATItem(clus,FATEOCMark());
GoToCluster(clus);
//precistenie clustra
for (elems=0;elems<fbr.BytesPerSector*fbr.SectorsPerCluster;elems++)
        fwrite(&c,1,1,f);
//DOT
memset(&de,' ',11);
de.sde.FileName[0]='.';
//velkost,atr, a startclus je nastaveny uz spravne
GoToCluster(clus);
fwrite(&de,sizeof(de),1,f);
//DOTDOT
de.sde.FileName[1]='.';
cnv32bto16(pclus,&de.sde.StartingCluster,&de.sde.ClustHI);
fwrite(&de,sizeof(de),1,f);
return 1;
}

unsigned  FATFileSystem::FATEOCMark(void)
{
switch (FAT)
        {
        case 0:return 0x0FF8;
        case 1:return 0xFFF8;
        case 2:return 0x0FFFFFF8;
        }
return 0;
}

int FATFileSystem::InsertFile(char *RealFileName,char *TargetFileName, bool LongName,bool FragmentFile)
{
FILE *f;
long size,deoff;
unsigned clus,elems,clussize,rsize,nclus,i;
char tmpret[500],tmpret1[500],tmpret2[500],*p,*buf,zaloha[1000];
LongNameCache lnc;
bool root;
unsigned long dclus,n;

strcpy(zaloha,TargetFileName);
TargetFileName=zaloha;
RemoveSlashes(TargetFileName);

if (FindDirectoryEntry(TargetFileName)!=0)
        return false;

elems=NumberOfFilePathElements(TargetFileName);

if (!(f=fopen(RealFileName,"rb")))
        return 0;

fseek(f,0,SEEK_END);
size=ftell(f);
fseek(f,0,SEEK_SET);

//cesta k suboru
if (elems==1)
        tmpret[0]='\0';
else
        GetPathElements(TargetFileName,tmpret,1,elems-1);
if (!LongName)
        deoff=GetFreeDEPosition(tmpret);
else
        {
        GetPathElements(TargetFileName,tmpret1,elems,elems);
        i=strlen(tmpret1);
        deoff=GetFreeDEPositions(i%13==0?i/13+1:i/13+2,tmpret,NULL,&n,&dclus,&root);
        }

if (deoff==0)
        {
        fclose(f);
        return 0;
        }

//teraz je vsetko pripravene na zapis suboru
memset(&de,0,sizeof(de));

if (!LongName)
        {
        GetPathElements(TargetFileName,tmpret,elems,elems);
        tmpret1[0]=tmpret2[0]='\0';
        p=strrchr(tmpret,'.');
        if (p!=NULL)
                {
                strcpy(tmpret2,p+1);
                *p='\0';
                }
        strcpy(tmpret1,tmpret);
        strcat(tmpret1,"                              ");
        strcat(tmpret2,"                              ");
        strupr(tmpret1);
        strupr(tmpret2);
        strncpy(de.sde.FileName,tmpret1,8);
        strncpy(de.sde.Extension,tmpret2,3);
        fseek(this->f,deoff,SEEK_SET);
        }
else
        {
        lnc.ProcessLongName(tmpret1);
        if (!lnc.PrepareToWriteLongName(TargetFileName,tmpret2,this))
                return 0;

        fseek(this->f,deoff,SEEK_SET);
        do
                {
                elems=lnc.CreateLDE(&de);
                fwrite(&de,sizeof(de),1,this->f);
                n++;
                if (!root && n==DEsPerCluster)
                        {
                        n=0;
                        dclus=GetFATItem(dclus);
                        GoToCluster(dclus);
                        }
                }
        while (elems>1); //1 je posledna v poradi
        memset(&de,0,sizeof(de));
        memcpy(&de,tmpret2,11);
        }

de.sde.WrtTime=FATDETime();
de.sde.WrtDate=FATDEDate();
de.sde.CrtTime=de.sde.WrtTime;
de.sde.CrtDate=de.sde.WrtDate;
de.sde.CrtTimeTenth=0;
de.sde.LstAccDate=de.sde.CrtDate;
de.sde.Reserved=0;
//toto tu pokazi offset v image - pred zapisom ho treba obnovit
deoff=ftell(this->f);
cnv32bto16((clus=GetFreeCluster(FragmentFile)),&de.sde.StartingCluster,&de.sde.ClustHI);
if (size==0) /* DONE : overit, ci prazdny subor ma mat zac. cluster 0 (alebo 1?) */
	{
        de.sde.StartingCluster=0; // JE TO NAOZAJ 0??????????????? - na 99% ano
	de.sde.ClustHI=0;
	}
de.sde.FileSize=size;
fseek(this->f,deoff,SEEK_SET);
fwrite(&de,sizeof(de),1,this->f);
// a mozme sa pustit do zapisu DAT!
clussize=fbr.BytesPerSector*fbr.SectorsPerCluster;
buf = new char [clussize];
clus=0;
while (size>0)
        {
        if (clus==0)
		{
		nclus=cnv16bto32(de.sde.StartingCluster,de.sde.ClustHI);
		if (nclus==0) //disk plny
			break;
		}
        else
                {
                nclus=GetFreeCluster(FragmentFile);
                if (nclus!=0)
			SetFATItem(clus,nclus);
		else
			{
			SetFATItem(clus,FATEOCMark()); //disk plny - aby sa to korektne zmazalo
			break;
			}
                }
        clus=nclus;
        rsize=fread(buf,1,clussize,f);
        GoToCluster(clus);
        fwrite(buf,1,rsize,this->f);
        size-=rsize;
        if (size==0)
                SetFATItem(clus,FATEOCMark());
        else
                SetFATItem(clus,1); //aby GetFreeCluster tento cluster nevratil 2-krat
        }
fclose(f);
if (size>0) //subor sa nezmestil
	DelFile(TargetFileName);
return (size==0);

}

bool FATFileSystem::CreateEmptyFileSystem(char*FileName, int Size, FATType Type, unsigned ClustSize)
{
unsigned ClusterCount,FSectCount,FATBits,Sectors,i;
char buf[512];
FAT32FSInfoSector f32fsi;

randomize();

if (InitSucc)
        return false;

//kontrola prip. hodnot ClustSize
switch (ClustSize)
        {
        case 1:
        case 2:
        case 4:
        case 8:
        case 16:
        case 32:
        case 64:
        case 128:break;
        default:return false;break;
        }

//najdeme mocninu 2 pre velkost
Size=(Size/512)*512;
ClusterCount=Size/(ClustSize*512);
Sectors=Size/512;

//kontrola poctu clustrov
switch (Type)
        {
        case FAT12:if (ClusterCount>=4085) return false;break;
        case FAT16:if (ClusterCount>=65525) return false;break;
        case FAT32:if (ClusterCount>=268435454) return false;break;
        }

//vypocet velkosti FAT
switch (Type)
        {
        case FAT12:FATBits=12;break;
        case FAT16:FATBits=16;break;
        case FAT32:FATBits=32;break;
        }
FSectCount=(Type==FAT12?(ClusterCount*FATBits)/8+1:(ClusterCount*FATBits)/8);
if (FSectCount%512>0)
        FSectCount=FSectCount/512+1;
else
        FSectCount/=512;

/*
//odoberieme 1 sector, mozno to stale bude dostatocne velke
if (((FSectCount-1)*512*8/FATBits)>=ClusterCount)
        FSectCount--;
*/

if ((f=fopen(FileName,"wb"))==NULL)
        return false;

//vytvorenie boot sectora
memset(&fbr,0,sizeof(fbr));
//jmp instrukcia:
fbr.jmp[0]=0xEB;
fbr.jmp[1]=0x34;
fbr.jmp[2]=0x90;

strncpy(fbr.OEMNameString,"MSWIN4.1",8);
fbr.BytesPerSector=512;
fbr.SectorsPerCluster=ClustSize;
fbr.ReservedSectors=Type==FAT32?32:1;
fbr.NumberOfFATs=2;

switch(Type)
        {
        case FAT12:
                        if (Size<1000000) //toto pre kompatibilitu s disketatmi
                                fbr.MaxRootEntries=112;
                        else
                                fbr.MaxRootEntries=224;
                        break;
        case FAT16:     fbr.MaxRootEntries=512;break;
        case FAT32:     fbr.MaxRootEntries=0;break;
        }


if (Sectors<65536 && (Type==FAT12 || Type==FAT16))
        {
        fbr.NumberOfSectors=Sectors;
        fbr.BigNumberOfSectors=0;
        }
else
        {
        fbr.NumberOfSectors=0;
        fbr.BigNumberOfSectors=Sectors;
        }

fbr.MediaDescriptorByte=0xF0; //removable media

if (Type==FAT12 || Type==FAT16)
        {
        fbr.SectorsPerFAT=FSectCount;
        fbr.FAT32Ext.FATSz32=0;
        }
else
        {
        fbr.SectorsPerFAT=0;
        fbr.FAT32Ext.FATSz32=FSectCount;
        }

//nasl. dve hodnoty sa tykaju geometrie disku, pre kompatibil. s floppy to bude takto:
if (Type==FAT12 && Size==DDFLOPPY)
        {
        fbr.NumberOfHeads=2;
        fbr.SectorsPerTrack=9;
        }
else
if (Type==FAT12 && Size==HDFLOPPY)
        {
        fbr.NumberOfHeads=2;
        fbr.SectorsPerTrack=18;
        }
//pre kompatibil. s inym diskom najma pod linuxom to bude takto
else
        {
        fbr.NumberOfHeads=0xff;
        fbr.SectorsPerTrack=0x3f;
        }

fbr.NumberOfHiddenSectors=0;

if (Type==FAT12 || Type==FAT16)
        {
        fbr.FAT16BPB.PhysicalDriveNumber=(Size==DDFLOPPY || Size==HDFLOPPY) ? 0:0x80;
        fbr.FAT16BPB.CurrentHead=0;
        fbr.FAT16BPB.Signature=0x29;
        fbr.FAT16BPB.SerialNumber=random(100000000);
        strncpy(fbr.FAT16BPB.Label,"NO NAME             ",11);
        strncpy(fbr.FAT16BPB.FileSystemID,(Type==FAT12)?"FAT12             ":"FAT16             ",8);
        }
else    //FAT32
        {
        fbr.FAT32Ext.ExtFlags=0; //fat mirroring active
        fbr.FAT32Ext.FSVer=0;
        fbr.FAT32Ext.RootClus=2;
        fbr.FAT32Ext.FSInfo=1;
        fbr.FAT32Ext.BkBootSec=6;
        memset(fbr.FAT32Ext.Resrvd1,0,12);

        fbr.FAT32BPB.PhysicalDriveNumber=0x80;
        fbr.FAT32BPB.CurrentHead=0;
        fbr.FAT32BPB.Signature=0x29;
        fbr.FAT32BPB.SerialNumber=random(100000000);
        strncpy(fbr.FAT32BPB.Label,"NO NAME              ",11);
        strncpy(fbr.FAT32BPB.FileSystemID,"FAT32          ",8);
        }


fbr.BootSignature=0xAA55;

//vytvorime subor
memset(buf,0,512);
for (i=0;i<Sectors;i++)
        fwrite(buf,512,1,f);


//zapiseme boot blok
fseek(f,0L,SEEK_SET);
fwrite(&fbr,sizeof(fbr),1,f);

if (Type==FAT32)
        {
        //pre FAT32 - FSInfo structure
        f32fsi.LeadSig=0x41615252;
        memset(f32fsi.Res1,0,480);
        f32fsi.StrucSig=0x61417272;
        f32fsi.FreeCount=f32fsi.NxtFree=0xFFFFFFFF;
        memset(f32fsi.Res2,0,12);
        f32fsi.TrailSig=0xAA550000;

        fseek(f,512,SEEK_SET);
        fwrite(&f32fsi,sizeof(f32fsi),1,f);

        //copy - backup boot
        fseek(f,6*512,SEEK_SET);
        fwrite(&fbr,sizeof(fbr),1,f);
        fwrite(&f32fsi,sizeof(f32fsi),1,f);
        }


fclose(f);

//nastavime FAT[0] a FAT[1] - na to inicializ. FS
Init(FileName,Type);
FATBits=fbr.MediaDescriptorByte;
switch (Type)
        {
        case FAT12:FATBits|=(0xF<<8);break; //treba nastavit este 4 bity
        case FAT16:FATBits|=(0xFF<<8);break;//este 8
        case FAT32:FATBits|=(0xFFFFF<<8);break; //este 20 bitov
        }

  /* DONE : dorobit veci pre FAT32 FSInfo a BootCopy */
SetFATItem(0,FATBits);
//FAT[1] musime nastavit nie na minimalnu FATEOC, ale microsoftiu
switch (Type)
        {
        case FAT12:SetFATItem(1,0x0FFF);break;
        case FAT16:SetFATItem(1,0xFFFF);break;
        case FAT32:SetFATItem(1,0x0FFFFFFF);break;
        }

//WARNING PRE FAT 32 TREBA OBSADIT CLUSTER 2 - OBSAHUJE ROOT
if (Type==FAT32)
        SetFATItem(2,FATEOCMark());


InitSucc=false;
fclose(f);

return true;
}

void FATFileSystem::InitFATBuffer(void)
        {
        unsigned i;
        if (FAT!=FAT32)
                {
                //nacitame celu FATku do buffra
                fseek(f,FirstFATSector*fbr.BytesPerSector,SEEK_SET);
                fread(FATBuf,fbr.SectorsPerFAT*fbr.BytesPerSector,1,f);
                }
        else
                {
                //FAT32 nacitame len cast alebo celu FAT - podla velkosti
                NumItems=32768;
                FirstBufItem=0;
                fseek(f,FirstFATSector*fbr.BytesPerSector,SEEK_SET);
                fread(FATBuf,NumItems*4,1,f);
                }
        }

//prva polozka FAT jo 0
void FATFileSystem::MoveFATBuffer(unsigned FirstItem)
        {
        //predpoklada sa FAT32
        WriteFATBuffer();
        FirstBufItem=FirstItem;
        fseek(f,FirstFATSector*fbr.BytesPerSector+FirstItem*4,SEEK_SET);
        fread(FATBuf,NumItems*4,1,f);
        }


void FATFileSystem::WriteFATBuffer(void)
        {
        unsigned ItemsToWrite,i;

        if (FAT!=FAT32)
                {
                fseek(f,FirstFATSector*fbr.BytesPerSector,SEEK_SET);
                for (i=0;i<fbr.NumberOfFATs;i++)
                        fwrite(FATBuf,fbr.SectorsPerFAT*fbr.BytesPerSector,1,f);
                }
        else
                {
                ItemsToWrite=(fbr.FAT32Ext.FATSz32*fbr.BytesPerSector/4)-FirstBufItem;
                if (ItemsToWrite>NumItems)
                        ItemsToWrite=NumItems;
                for (i=0;i<fbr.NumberOfFATs;i++)
                        {
                        fseek(f,FirstFATSector*fbr.BytesPerSector+FirstBufItem*4+fbr.FAT32Ext.FATSz32*fbr.BytesPerSector*i,SEEK_SET);
                        fwrite(FATBuf,ItemsToWrite*4,1,f);
                        }
                }
        }

bool FATFileSystem::SetAttributes(char *NameOfObject, unsigned Attr)
        {
        long offs;
        char zaloha[1000];

        strcpy(zaloha,NameOfObject);
        NameOfObject=zaloha;

        if ((offs=FindDirectoryEntry(NameOfObject))==0)
                return false;
        //zachovanie nastavenia atributu adresara
        if (de.sde.Attributes&ATTR_DIRECTORY)
                de.sde.Attributes=Attr|ATTR_DIRECTORY;
        else
                de.sde.Attributes=Attr;

        fseek(f,offs,SEEK_SET);
        fwrite(&de,sizeof(de),1,f);
        return true;
        }

unsigned FATFileSystem::TranslateAttributes(char *AttrRet)
        {
        unsigned result=0;

        strupr(AttrRet);
        if (strchr(AttrRet,'R')!=NULL)
                result|=ATTR_READ_ONLY;
        if (strchr(AttrRet,'H')!=NULL)
                result|=ATTR_HIDDEN;
        if (strchr(AttrRet,'S')!=NULL)
                result|=ATTR_SYSTEM;
        if (strchr(AttrRet,'A')!=NULL)
                result|=ATTR_ARCHIVE;
        return result;
        }

bool FATFileSystem::ReadFile(char *EFSName, char *RealFileName)
        {
        char temp[1000],*buf;
        long offs;
        FILE *rf;
        unsigned clus,sz,clussz=fbr.BytesPerSector*fbr.SectorsPerCluster;

        strcpy(temp,EFSName);
        EFSName=temp;

        //ak subor v EFS neexistuje alebo je to adresar
        if ((offs=FindDirectoryEntry(EFSName))==0 || (de.sde.Attributes&ATTR_DIRECTORY))
		{
		LastErrNo=0;
                return 0;
		}

        //ciel. sub. sa neda otvorit
        if ((rf=fopen(RealFileName,"wb"))==NULL)
		{
		LastErrNo=1;
                return 0;
		}

        if (de.sde.FileSize>0)
                {
                sz=de.sde.FileSize;
                buf=new char [clussz];
                clus=cnv16bto32(de.sde.StartingCluster,de.sde.ClustHI);

		if (clus>NumberOfClusters+1 || clus<2)
				{
				LastErrNo=2;
				delete buf;
				return false;
				}
                while (sz>0)
                        {
			if (clus>NumberOfClusters+1 || clus<2)
				{
				LastErrNo=3;
				delete buf;
				return false;
				}

                        GoToCluster(clus);
                        fread(buf,1,clussz,f);
                        sz-=fwrite(buf,1,sz>=clussz?clussz:sz,rf);
                        clus=GetFATItem(clus);
                        }
                delete buf;
                }
        fclose(rf);
        return true;
        }



unsigned int FATFileSystem::GetNumberOfClusters(void)
{
        //DONE: Add your source code here
        return NumberOfClusters;
}

DirectoryEntry FATFileSystem::GetDE(void)
{
        //DONE: Add your source code here
        return de;
}

bool FATFileSystem::WriteDE(char* NameOfObject, DirectoryEntry * inp_de)
{
        //DONE: Add your source code here
        long offs;

        if ((offs=FindDirectoryEntry(NameOfObject))==0)
                return false; //objekt neexistuje
        fseek(f,offs,SEEK_SET);
        fwrite(inp_de,sizeof(DirectoryEntry),1,f);
        return true;
}

int FATFileSystem::WriteSomethingToFS(long Offset,void *Ptr, long Lng)
{
fseek(f,Offset,SEEK_SET);
return fwrite(Ptr,Lng,1,f);
}

//////////////////// trieda na pracu s dlhymi menami
void LongNameCache::ClearCache(void)
        {
        memset(WideLongName,0,sizeof(WideLongName));
        memset(NarrowLongName,0,sizeof(NarrowLongName));
        Checksum=LastNum=0;
        Valid=Last=First=Checksummed=false;
        }

void LongNameCache::ConvertFromUnicode(void)
        {
        sprintf(NarrowLongName,"%ls",WideLongName);
        }

void LongNameCache::ProcessLongEntry(DirectoryEntry de)
        {
        wchar_t temp[13];
        unsigned char sum,i,j;
        unsigned char *p;
	lde2nlde(&(de.lde));



        if (((nlde.LDIR_Attr & ATTR_LONG_NAME_MASK)==ATTR_LONG_NAME) && (nlde.LDIR_Ord!=0xE5))
                {
                //ak sme nasli poslednu LDE - zacneme novu sekvenciu
                if (nlde.LDIR_Ord & LAST_LONG_ENTRY)
                        {
                        ClearCache();
                        Last=Valid=true;
                        Checksum=nlde.LDIR_Checksum;
                        LastNum=MaxNum=nlde.LDIR_Ord & (~LAST_LONG_ENTRY); //takto snad ziskame poradove cislo
                        //prekopirujeme retazce
                        wmemcpy(temp,nlde.Name1,5);
                        wmemcpy(temp+5,nlde.Name2,6);
                        wmemcpy(temp+11,nlde.Name3,2);

                        wmemcpy(LongNameParts[LastNum],temp,13);
			/* ak posledna cast dlheho mena nie je doplnena za \0 znakmi FFFFFFFF, windows to poklada
			za chybu, linux nie. Tento system tiez nie (zatial, ale uz nie dlho), dam sem wmemcpy, aby to
			skopirovalo aj FFFFF */

			for (i=0,j=0;i<13;i++)
				{
				if (j==0 && LongNameParts[LastNum][i]==L'\0')
					{
					j=1;
					continue;
					}
				if (j==1 && (LongNameParts[LastNum][i]&0xFFFF)!=0xFFFF)
					{
					Valid=false;
					}
				}
                        }
                else
                        {
                        //pokracujeme v sekvencii
                        //kontrola poradia a checksumu
                        i=nlde.LDIR_Ord;
                        if (i!=--LastNum)
                                Valid=false;
                        if (Checksum!=nlde.LDIR_Checksum)
                                Valid=false;
                        if (Valid)
                                {
                                wcsncpy(temp,nlde.Name1,5);
                                wcsncpy(temp+5,nlde.Name2,6);
                                wcsncpy(temp+11,nlde.Name3,2);

                                wcsncpy(LongNameParts[LastNum],temp,13);
                                }
                        }
                        //prva polozka
                        if (Valid && LastNum==1)
                                {
                                First=true;
                                //spojime retazec
                                for (i=1;i<=MaxNum;i++)
                                        wcsncat(WideLongName,LongNameParts[i],13);
                                //prekonvertujeme na OEM znakovu sadu z UNICODu
                                ConvertFromUnicode();
                                }
                      }
                else  //nasli sme nieco ine ako LONG ENTRY
                      {
                      //pokial to nie je volume id alebo zmazana polozka je to odpovedajuca
                      //short de

                        if ((nlde.LDIR_Attr & ATTR_VOLUME_ID) || (nlde.LDIR_Ord==0xE5))
                                return;

                        sum=ComputeChecksum((char*)&de);
                        if (sum!=Checksum || !Valid || !First || !Last)
                                {
                                Valid=false;
                                ClearCache();
                                }
                        else
                                Checksummed=true; //dlhe meno je uz aj oceksamovane

                        }

        }

void LongNameCache::ProcessLongName(char *lname)
        {
        wchar_t wr[]=L"%s";
        int i,p;
	int sz=sizeof(WideLongName)/sizeof(wchar_t);
	int ln,ln2;

        strcpy(NarrowLongName,lname);
        swprintf(WideLongName,sz,wr,lname);
	ln=wcslen(WideLongName);
	//ak je dlzka mena taka, ze sa vojde presne do n poloziek, nezacina sa nova polozka kvoli znaku \0
	if (ln%13!=0)
		ln++;
        for (i=0,p=1;i<ln;i+=13,p++)
                {
		memset(LongNameParts[p],0xFF,sizeof(wchar_t)*13);
		ln2=ln-i;
		wmemcpy(LongNameParts[p],WideLongName+i,ln2>13?13:ln2);
                }
        MaxNum=p-1;
        LastNum=MaxNum;
        }

bool LongNameCache::PrepareToWriteLongName(char *path, char * shortalias, FATFileSystem *ffs)
 /* TODO : dorobit krajsie kratke aliasy z kratkych dlhych mien */       {
        char fname[300],pname[500],shname[11],*p,tret[8],temp[500],ext[3];
        int i,j,k;

        //oddelime meno suboru
        i=NumberOfFilePathElements(path);
        GetPathElements(path,fname,i,i);
        if (i>1)
                GetPathElements(path,pname,1,i-1);
        else
                pname[0]='\0';

        memset(shname,' ',11);
        memset(ext,' ',3);
        //velmi primitivny alg. generovania kratkeho mena
        p=strrchr(fname,'.');
        if (p!=NULL)
                {
                *p='\0';
                strncpy(ext,p+1,3);
                }
        strncpy(shname,fname,8);
        memcpy(shname+8,ext,3);
        for (i=0;i<11;i++)
                {
                if (i<8 && (shname[i]==' ' || shname[i]=='\0' || shname[i]=='.'))
                        shname[i]='_';
                if (i>=8 && shname[i]=='\0')
                        shname[i]=' ';
                }

        i=1;
        do
                {
                sprintf(tret,"~%d",i);
                j=strlen(tret);
                memcpy(shname+8-j,tret,j);
                strcpy(temp,pname);
                strcat(temp,"\\");
                strxncat(temp,shname,8);
                if (shname[8]!=' ')
                        {
                        strcat(temp,".");
                        strxncat(temp,shname+8,3);
                        }
                i++;
                if (i>=100000)
                        return false;
                RemoveSlashes(temp);
                }
        while (ffs->FindDirectoryEntry(temp)>0);
        memcpy(shortalias,shname,11);
        shortalias[11]='\0';
        strupr(shortalias);
        Checksum=ComputeChecksum(shortalias);
        return true;
}

unsigned char LongNameCache::ComputeChecksum(char *p)
        {
        unsigned char sum=0,i;
        for (i=11;i!=0;i--)
                {
                sum=((sum & 1) ? 0x80 : 0) + ( sum >> 1) + *p++;
                }
        return sum;
        }

int LongNameCache::CreateLDE(DirectoryEntry *de)
        {
	int i;

	nlde.LDIR_Ord=LastNum;
        if (LastNum==MaxNum)
                nlde.LDIR_Ord|=LAST_LONG_ENTRY;
        nlde.LDIR_Attr=ATTR_LONG_NAME;
        nlde.LDIR_Type=0;
        nlde.LDIR_Checksum=Checksum;
        nlde.LDIR_FstClustLO=0;

        wmemcpy(nlde.Name1,LongNameParts[LastNum],5);
        wmemcpy(nlde.Name2,LongNameParts[LastNum]+5,6);
        wmemcpy(nlde.Name3,LongNameParts[LastNum]+11,2);

	nlde2lde(&(de->lde));

        return LastNum--;
        }

void LongNameCache::lde2nlde(LongDirectoryEntry *src)
{
int i;

if (sizeof(LongDirectoryEntry)==sizeof(NonPortableLongDirectoryEntry))
	{
	memcpy(&nlde,src,sizeof(LongDirectoryEntry));
	return;
	}

memset(&nlde,0,sizeof(nlde));
nlde.LDIR_Ord=src->LDIR_Ord;
nlde.LDIR_Attr=src->LDIR_Attr;
nlde.LDIR_Type=src->LDIR_Type;
nlde.LDIR_Checksum=src->LDIR_Checksum;
nlde.LDIR_FstClustLO=src->LDIR_FstClustLO;

for (i=0;i<5;i++)
	nlde.Name1[i]=src->Name1[i];

for (i=0;i<6;i++)
	nlde.Name2[i]=src->Name2[i];

for (i=0;i<2;i++)
	nlde.Name3[i]=src->Name3[i];
}

void LongNameCache::nlde2lde(LongDirectoryEntry *dst)
{
int i;

if (sizeof(LongDirectoryEntry)==sizeof(NonPortableLongDirectoryEntry))
	{
	memcpy(dst,&nlde,sizeof(LongDirectoryEntry));
	return;
	}

memset(dst,0,sizeof(LongDirectoryEntry));
dst->LDIR_Ord=nlde.LDIR_Ord;
dst->LDIR_Attr=nlde.LDIR_Attr;
dst->LDIR_Type=nlde.LDIR_Type;
dst->LDIR_Checksum=nlde.LDIR_Checksum;
dst->LDIR_FstClustLO=nlde.LDIR_FstClustLO;

for (i=0;i<5;i++)
	dst->Name1[i]=nlde.Name1[i]&0xFFFF;

for (i=0;i<6;i++)
	dst->Name2[i]=nlde.Name2[i]&0xFFFF;

for (i=0;i<2;i++)
	dst->Name3[i]=nlde.Name3[i]&0xFFFF;
}

char * FATFileSystem::GetLastError(void)
	{
	switch (LastErrNo)
		{
		case 0:
			return "Hladany subor neexistuje alebo to je adresar";
			break;
		case 1:
			return "Nemozno vytvorit cielovy subor v realnom FS";
			break;
		case 2:
			return "Nezmyselny zaciatocny cluster suboru";
			break;
		case 3:
			return "Nezmyselny cluster v retazci clustrov suboru";
			break;
		default:
			return "Neznama chyba";
			break;
		}
	}

