//LINUX verzia resp. gcc
//hlavickovy subor pre triedu FATFileSystem - trieda poskytuje zakl. pracu s FAT fs
//pouziva konzolu (printf)
// upraveny pre 32bitove prostredie (original vznikol v 16b)
// kompilovat s bajtovym zarovnanim!!!
//WARNING ---------- CLUSHi je uplne ignorovane+++UZ JE DOROBENE
//TRIEDA PRACUJE SO SPATNYMI LOMITKAMI -- neskor zavediem konverzne funkcie
//JEDNA VEC MI LEZIE NA NERVY ---- wchar_t je 32 bitov

#ifndef FatlibH
#define FatlibH

#define __PACKED __attribute__ ((packed))


#include <stdio.h>

//funkcie produkuju datum/cas vo formate potrebnom pre zapis do DE
// bezargumentove verzie vratia aktualny cas/datum
unsigned short FATDEDate(unsigned short d, unsigned short m,unsigned short r);
unsigned short FATDEDate(void);
unsigned short FATDETime(unsigned short h, unsigned short m,unsigned short s);
unsigned short FATDETime(void);

//tieto funkcie pracuju opacne
void UnFATDEDate(unsigned short DEDate, unsigned *d, unsigned *m, unsigned *r);
void UnFATDETime(unsigned short DETime, unsigned *h, unsigned *m, unsigned *s);

// praca s cestami
//odstrani zaciatocne/konecne spatne lomitka
char* RemoveSlashes(char *ret);
//vrati pocet casti cesty oodel. spat. lomitkom
unsigned NumberOfFilePathElements (char *ret);
//vrati pozad.casti cesty
void GetPathElements(char *ret,char *dest,unsigned firstE, unsigned lastE);

//funkcia spoji dva retazce, max n znakov, ukonci sa pri vyskyte medzery
void strxncat(char *rdest,char *rsrc,int n);

void cnv32bto16(unsigned Src, unsigned short *LoWord, unsigned short *HiWord);
unsigned cnv16bto32(unsigned short LoWord, unsigned short HiWord);

struct BiosParameterBlock
	{
	unsigned char 	PhysicalDriveNumber;
	unsigned char 	CurrentHead;
	unsigned char 	Signature;
	long            SerialNumber;
	char		Label[11];
	char		FileSystemID[8];
	} __PACKED;
struct FAT32Extension
        {
        unsigned        FATSz32;
        unsigned short  ExtFlags;
        unsigned short  FSVer;
        unsigned        RootClus;
        unsigned short  FSInfo;
        unsigned short  BkBootSec;
        unsigned char   Resrvd1[12];
        }__PACKED;

struct FATBootRecord
	{
	char 			jmp[3];
	char 			OEMNameString[8];
	unsigned short    	BytesPerSector;
	unsigned char		SectorsPerCluster;
	unsigned short 		ReservedSectors;
	unsigned char 		NumberOfFATs;
	unsigned short		MaxRootEntries;
	unsigned short		NumberOfSectors; //len pre male disky
	unsigned char		MediaDescriptorByte;
	unsigned short		SectorsPerFAT;
	unsigned short 		SectorsPerTrack;
	unsigned short		NumberOfHeads;
	unsigned long int 	NumberOfHiddenSectors;
	unsigned long int 	BigNumberOfSectors; //len pre velke disky
        union
                {
	        BiosParameterBlock	FAT16BPB;       //pre FAT12/16
                FAT32Extension          FAT32Ext;       //FAT 32 only
                }__PACKED;
        BiosParameterBlock              FAT32BPB;       //FAT32 ONLY
	char			RestOfSector[420];
	unsigned short		BootSignature;
	}__PACKED;

#define FATBootRecordSize       512
#define ShortDirectoryEntrySize	32
#define LongDirectoryEntrySize	32
#define DirectoryEntrySize	32


#define ATTR_READ_ONLY          0x01
#define ATTR_HIDDEN             0x02
#define ATTR_SYSTEM             0x04
#define ATTR_VOLUME_ID          0x08
#define ATTR_DIRECTORY          0x10
#define ATTR_ARCHIVE            0x20
#define ATTR_LONG_NAME          (ATTR_READ_ONLY|ATTR_HIDDEN|ATTR_SYSTEM|ATTR_VOLUME_ID)
#define ATTR_LONG_NAME_MASK     (ATTR_READ_ONLY|ATTR_HIDDEN|ATTR_SYSTEM|ATTR_VOLUME_ID|ATTR_DIRECTORY|ATTR_ARCHIVE)
#define LAST_LONG_ENTRY         0x40

#define DDFLOPPY                737280
#define HDFLOPPY                1474560


struct ShortDirectoryEntry
	{
	char 			FileName[8];
	char 			Extension[3];
	unsigned char 		Attributes;
	unsigned char		Reserved;
        unsigned char           CrtTimeTenth;
        unsigned short          CrtTime,
                                CrtDate,
                                LstAccDate,
                                ClustHI,                //0 pre FAT12/16
                                WrtTime,
				WrtDate,
				StartingCluster;
	unsigned long		FileSize;
	}__PACKED;

//kedze vsak pod linuxom ma wchar_t pre istotu 32 bitov (hoci Unikodovy znak ma iba 16 bitov)
//pod windowsom 16 bitov


struct NonPortableLongDirectoryEntry
        {
        unsigned char           LDIR_Ord;
        wchar_t                 Name1[5];
        unsigned char           LDIR_Attr,
                                LDIR_Type,
                                LDIR_Checksum;
        wchar_t                 Name2[6];
        unsigned short          LDIR_FstClustLO;
        wchar_t                 Name3[2];
        }__PACKED;


struct LongDirectoryEntry
        {
        unsigned char           LDIR_Ord;
        unsigned short		Name1[5];
        unsigned char           LDIR_Attr,
                                LDIR_Type,
                                LDIR_Checksum;
        unsigned short          Name2[6];
        unsigned short          LDIR_FstClustLO;
        unsigned short          Name3[2];
        }__PACKED;


union   DirectoryEntry
        {
        ShortDirectoryEntry             sde;
        LongDirectoryEntry              lde;
        }__PACKED;

enum FATType {FAT12,FAT16,FAT32};

struct FAT32FSInfoSector
        {
        unsigned LeadSig;
        unsigned char Res1[480];
        unsigned StrucSig;
        unsigned FreeCount;
        unsigned NxtFree;
        unsigned char Res2[12];
        unsigned TrailSig;
        }__PACKED;

class FATFileSystem
{
protected: //aby sa to zdedilo a aby to bolo pristupne
	int 			InitSucc; //indikator uspesnej inic.
	FATBootRecord		fbr;

        DirectoryEntry          de;

	FILE*			f;
	long 			RootPos,
				SystemSectors, //pocet sektorov pred 1. datovym clusterom
                                FirstDataSector,
                                FirstFATSector,
                                DEsPerCluster; //pocet DE v 1 clustri
	char*                   FATImageName; //meno suboru pre FS
	FATType                 FAT; //typ FAT-ky
        unsigned                NumberOfClusters; //NEW
        unsigned                LastAllocatedCluster;//NEW posledny alokovany cluster
                                                        //sluzi to na zrychlenie vyhladania volneho clustra

        //NEW - buffer na FATku -128k(max. velkost F16)
        bool                    FATBuffering;
        char                    *FATBuf;
        unsigned                FirstBufItem,NumItems;
        void                    InitFATBuffer(void);
        void                    MoveFATBuffer(unsigned FirstItem); //presunie FATBuffer na pozadovanu polozku - len pri FAT32
        void                    WriteFATBuffer(void);

	int 			LastErrNo; //cislo posl. chyby, zatial len pri citani suborov
	public:
	char *			GetLastError(void);
	FATFileSystem(void);
	~FATFileSystem(void);

	//inicializacia systemu
	int Init(char *fatimagename, FATType type, bool FATBuff=false);
	//nova funkcia -- ukoncenie cinnosti EFS - nie je nutne nicit instanciu(aspon dufam)
	void Close(void);
        //funkcie - navratova hodnota 0-FAIL
        protected:
	int ReadBootRecord(char *filename);
        public:
	int PrintDir(char *dir);
	//funkcia vyhlada (s)DE zadaneho suboru/adresara, vrati offset SDE, pri neuspechu 0
        //name moze byt dlhy alebo kratky nazov
	//ako bonus v poli vrati ofsety zaciatkov LDE, ktore patria danej polozke -- pouziva sa pri mazani
	//dlhych mien presahujucich cluster, max. 255/13 ~~~ 20 LDEs, vsetky polozky su platne az po prvu nulu
	//SMERNIK NA POLE ------- POLE MUSI MAT ASPON 20 POLOZIEK(inak hrozi pad programu)
        long FindDirectoryEntry(char *name, long *DESoffsets=NULL);
	//vypise info o systeme
	void PrintInfo(void);
	//vrati n-tu polozku FAT-ky
	unsigned GetFATItem(unsigned n);
	//nastavi n-tu polozku FAT-ky
	void SetFATItem(unsigned n, unsigned value);
	//zmaze len zadany subor - PODPORUJE DLHE NAZVY!
        //korektne je aj zmazat prazdny adresar, zmazanie plneho sposobi vznik stratenych clustrov!!!!
	int DelFile(char *name);
        //prejde na zadany cluster
        void GoToCluster(unsigned cl);
        //vrati pocet volnych bajtov
        unsigned FreeSpace(void);
        //vrati pocet volnych clustrov
        unsigned FreeClusters(void);
        //vrati cislo volneho clustra, inak 0
        //ak je fragments=true nevrati najbl. volny cluster ale nahodny v. cl. - subory budu fragmentovane
        unsigned GetFreeCluster(bool Fragments=false);
        //vrati offset prazdnej DE v zadanom adresari, inak 0 (a cluster adresara)
        //teraz modifikacia pre dlhe nazvy - extra parameter pre pocet pozadovanych DE
        //navrat 0 v pripade neupechu
        long GetFreeDEPosition(char *path,unsigned long *parentcluster=NULL);
        //posl. parameter udava poradove cislo DE v clustri, na ktore ukazuje offs, dolezite pre dlhe mena,dalsi. par. je cislo clustra, kde sa nach. offs, posl. je priznak rootu
        long GetFreeDEPositions(int DESNeeded,char *path,unsigned long *parentcluster=NULL, unsigned long *NumberOfDEPosition=NULL, unsigned long *NumberOfCluster=NULL,bool *Root=NULL);
        unsigned FATEOCMark(void);
        //vytvori zadany adresar, v pripade uspechu vrati 1, meno nesmie obsahovat ., len kratky nazov
        //ak sa zada druhy parameter true, vytvori sa dlhy nazov
        int CrtDirectory(char* path, bool longname=false);
        //vlozi subor do EFS
        //ak je predposl. parameter true, funkcia vygeneruje pre subor dlhy nazov
        //posledny par. true - potom funkcia skusi vytvorit fragmentovany subor
	//POZOR ------------------- NEKONTROLUJE, ci sa subor do EFS zmesti!!!!, ak sa nezmesti pokusi sa ho zmazat
        int InsertFile(char *RealFileName,char *TargetFileName,bool LongName=false,bool FragmentFile=false);

        //vytvori prazdny filesystem o zadanej velkosti a type
        // pre velkost mozno pouzit konstanty HDFLOPPY alebo DDFLOPPY
        //volat len pri neinicializovanom objekte
        //vzdy 512 bytes/sector, clustersize v sektoroch, max. 64K (128 sectors)
        //povolene hodnoty su 1,2,4,8,16,32,64,128
        bool CreateEmptyFileSystem(char* FileName,int Size, FATType Type,unsigned ClustSize);

        //nastavi atributy zadanemu objektu(odporuca sa pouzivat iba RHSA atributy)
        bool SetAttributes(char *NameOfObject, unsigned Attr);
        //retazec obsahujuci pismena rhsa/RHSA zmeni na cislo zodp. atrib. suboru/adresara
        unsigned TranslateAttributes(char *AttrRet);

        //precita subor z EFS do realneho FS
        //podporuje dlhe mena
        bool ReadFile(char *EFSName, char *RealFileName);
        unsigned int GetNumberOfClusters(void);
        //vrati aktualnu hodnotu DE objektu triedy - vhodne na ziskanie informacii o najdenom
        //objekte okamzite po volani FindDirectoryEntry (a pripadnu modif. pomocou WriteDE)
        DirectoryEntry GetDE(void);
        //zapise de dany objekt - pouzitie: modifikacia atributov, datumu, casu, ...
        bool WriteDE(char* NameOfObject, DirectoryEntry * inp_de);
        //tato funkcia zapise "nieco" do EFS - pouziva sa pri vyrobe chyb
        int WriteSomethingToFS(long Offset,void *Ptr, long Lng);
        };

struct LongNameCache    {
                        wchar_t                 	WideLongName[300];
                        wchar_t                 	LongNameParts[20][13];
                        char                    	NarrowLongName[300];
                        unsigned char           	Checksum, LastNum, MaxNum;
                        bool                    	Valid, Last, First, Checksummed;
			NonPortableLongDirectoryEntry	nlde;
			void ClearCache(void);
                        void ProcessLongEntry(DirectoryEntry de); //vyextraktuje z DE cast dlheho nazvu
                        void ConvertFromUnicode(void); //konverzia WideLongName ->> NarrowLongName
                        void ConvertToUnicode(void); //konverzia NarrowLongName ->> WideLongName
                        void ProcessLongName(char *lname); //rozdeli dlhe meno na casti, len meno, ziadne cesty, konv. na UNICODE
                        // do bufra shortalias zapise SDE alias (kratke meno), pokial sa objekt s dlhym menom bude nach. v adres. path
                        // treti argument je pointer triedu FATFileSystem, zistenie ci dany objekt existuje
                        // toto je potrebne pre vytvorenie jednoznacneho short aliasu
                        bool PrepareToWriteLongName(char *path, char * shortalias, FATFileSystem *ffs);
                        //spocita checksum z kratkeho nazvu
                        unsigned char ComputeChecksum(char *c);
                        //Tato funkcia naplni de. navratova hodnota urcuje poradove cislo casti dlheho nazvu
                        //treba volat a zapisovat vzniknutu DE dovtedy kym funkcia nevrati 1 (prva de - idu odzadu)
                        //volanie je korektne iba ak predtym sa volalo PrepareTo...(..) a ProcessLongName(..)
                        //na poradi volania tychto dvoch funkcii nezalezi
                        int CreateLDE(DirectoryEntry *de);
			//funkcie na prevod longde na nonportlongde a opacne ---
			//vsetko kvoli wchar_t(windows-16b, linux-32b)
			void lde2nlde(LongDirectoryEntry *src);
			void nlde2lde(LongDirectoryEntry *dst);
                        };


#endif

