#include "ngramanalyzer.h"

inline int HashString(char* s, int lng)
	{
	int h=0;

	while (*(s+1))
		{
		h=(h+(((unsigned char)*s))*256)%lng;
		s++;
		}
	h=(h+((unsigned char)*s))%lng;
	return h;
	}


NgramAnalyzer::NgramAnalyzer(int TablSze, int Stp)
	{
	wbs=sizeof(workbuf);
	htabler=NULL;
	htablecnt=NULL;
	TableSize=TablSze;
	Step=Stp;
	}

void NgramAnalyzer::NewToken(void)
	{
	ngramlng=1;
	bufp=0;
	workbuf[0]='_';
	workbuf[1]='\0';
	strcat(workbuf,tbuf);
	toklng=strlen(workbuf);
	}

bool NgramAnalyzer::GetNextNgram(void)
	{
	if (ngramlng>5)
		return false;
	strncpy(ngram,workbuf+bufp,ngramlng);
	bufp++;
	if (toklng<bufp+ngramlng) //ngramy dlzky ngramlng su vycerpane, ideme dalej
		{
		bufp=0;
		ngramlng++;
		toklng++;
		strcat(workbuf,"_");
		}
	ngram[ngramlng]='\0';
	return true;
	}

map<string,int>* NgramAnalyzer::Analyze(Tokenizer *tok)
	{
	int e,cnt=0;
	map<string,int> *mapka;
	map<string,int>::iterator it;
	string s;

	mapka=new map<string,int>;
	tbuf=tok->GetBuffAddr();

	while ((e=tok->GetNextToken())==1)
		{
		NewToken();
		while (GetNextNgram())
			{
			//vyhladame
			cnt++;
			s=ngram;
			if ((it=mapka->find(s))!=mapka->end())
				it->second++;
			else
				mapka->insert(make_pair(s,1));
			}
		}
	if (e!=0)
		{
		ErrNum=1;
		delete mapka;
		return NULL;
		}
	//printf("Pocet sprac. n-gramov:%d\n",cnt);
	return mapka;
	}

multimap<int, string>* NgramAnalyzer::Srt(map<string,int>* input)
	{
	multimap<int, string> *mapka=new multimap<int, string>;
	map <string, int> :: iterator i1,i2;
	int cnt=0;

	for (i1=input->begin(), i2=input->end(); i1!=i2; i1++, cnt++)
		mapka->insert(make_pair(i1->second,i1->first));
	return mapka;
	}

map<string, int> * NgramAnalyzer::CreateProfile(multimap <int, string> *input, int maxsize)
	{
	map<string, int> *profile = new map <string, int>;
	multimap <int, string>::reverse_iterator i1,i2;
	int cnt;

	for (i1=input->rbegin(), i2=input->rend(), cnt=0; i1!=i2 && cnt<maxsize;i1++, cnt++)
		profile->insert(make_pair(i1->second,cnt));

	return profile;
	}

double NgramAnalyzer::ProfileDistance(map<string, int> *prof1, map<string, int> * prof2, double *podobnost)
	{
	map<string, int>::iterator i1, i2, oe, f;
	map<string, int> *other;
	double dst=0, p=max(prof1->size(), prof2->size()),mdst=(prof1->size()*p+prof2->size()*p);
	int mp2=prof2->size();

	int k=0;
	//printf("Profily>%d %d max %lf\n",prof1->size(),prof2->size(),p);

	if (prof1->size()>prof2->size())
		{
		i1=prof2->begin();
		i2=prof2->end();
		other=prof1;
		}
	else
		{
		i1=prof1->begin();
		i2=prof1->end();
		other=prof2;
		}
	oe=other->end();
	while (i1!=i2)
		{
		k++;
		if ((f=other->find(i1->first))!=oe)
			{
			dst+=abs(f->second-i1->second);
			//other->erase(f);
			mp2--;
			}
		else
			dst+=p;
		i1++;
		}
	dst+=p*mp2;

	//printf ("Pocet krokov:%d\n, maxv:%lf\n",k,mdst);
	if (podobnost!=NULL)
		*podobnost=(1.00-(dst/mdst))*100.0;
	return dst;
	}

map<string,int>* NgramAnalyzer::AnalyzeWHash(Tokenizer *tok)
	{
	int e,hash,cnt;
	map<string,int> *mapka;
	string s;
	char *pc;

	mapka=new map<string,int>;
	tbuf=tok->GetBuffAddr();

	if (!htabler)
		htabler=new char[TableSize*8];
	if (!htablecnt)
		htablecnt=new int[TableSize];

	memset(htabler,0,TableSize*8);
	memset(htablecnt,0,TableSize);

	while ((e=tok->GetNextToken())==1)
		{
		NewToken();
		//fprintf(stderr,"TOK\n");
		while (GetNextNgram())
			{
			//vyhladame
			//n-gram je v prem. ngram
   			hash=HashString(ngram,TableSize);
			pc=htabler+8*hash;
			cnt=0;
			while (*(pc) && strcmp(pc,ngram)!=0)
				{
				hash=(hash+Step)%TableSize;
				pc=htabler+8*hash;
				cnt++;
				if (cnt==TableSize-1)
					{
					//printf("Preplnena hash. tabulka\n");
					ErrNum=0;
					delete mapka;
					return NULL;
					}
				}
			if (!(*pc))
				strcpy(pc,ngram);
			htablecnt[hash]++;
			}
		}
	if (e!=0)
		{
		ErrNum=1;
		//printf("Preplneny buffer tokenizera\n");
		delete mapka;
		return NULL;
		}
	//printf("Pocet sprac. n-gramov:%d\n",cnt);
	for (cnt=0, pc=htabler;cnt<TableSize;cnt++, pc+=8)
		if (*pc)
			mapka->insert(make_pair(pc,htablecnt[cnt]));
	return mapka;
	}

NgramAnalyzer::~NgramAnalyzer(void)
	{
	if (htabler)
		delete htabler;
	if (htablecnt)
		delete htablecnt;
	}
char* NgramAnalyzer::GetLastError(void)
	{
	switch (ErrNum)
		{
		case 0:
			return "Preplnena hash. tabulka";
			break;
		case 1:
			return "Preplneny buffer tokenizera";
			break;
		default:
			return "Neznama chyba";
		}
	}
