#include "tokenizer.h"
#include <stdio.h>
#include <ctype.h>
#include "ngramanalyzer.h"

int main(int argc, char ** argv)
	{
	Tokenizer tok;
	NgramAnalyzer nga;
	map<string,int> *m, *profile1, *profile2;
	map<string,int>::iterator i1,i2;
	multimap<int,string> *n;
	int verb=0, exppars=3, cache=0, ff=1, sf=2, i, hash=0, ifile=-1;
	double dst,sim;
	FILE *proffile;
	char buf1[1500], buf2[1500], buf [1000], m1[1000], m2[1000];

	for (i=1;i<argc;i++)
		if (argv[i][0]=='-')
			{
			exppars++;
			ff++;
			sf++;
			}

	for (i=1;i<ff;i++)
		{
		if (strchr(argv[i],'c'))
			cache=1;
		if (strchr(argv[i],'v'))
			verb=1;
		if (strchr(argv[i],'h'))
			hash=1;
		if (strchr(argv[i],'i'))
			{
			ifile=1;
			exppars-=2;
			}
		}

	if (argc!=exppars)
		{
		printf("Chyba parametrov!\n");
		printf("ngramcmp 1.0\n");
		printf("Porovnanie podobnosti (textovych) suborov na zaklade n-gramov.\n");
		printf("Pri porovnani dvoch suborov program vypise na standardny vystup podobnost \nsuborov vpercentach.\n Vpripade porovnavania viacerych suborov (prepinac -i)\nprogram takisto vypisuje na standardny vystup\npodobnosti jednotlivych dvojic porovnavanych suborov,\njeden riadok vystupu zodpoveda jednej porovnanej dvojici. Ak sa pouzije prepinac -v, \nprogram vypisuje\nviac informacii oporovnavanych suboroch.\n");
		printf("Spustenie aargumenty prikazoveho riadku:\n\tngramcmp [-c] [-h] subor1 subor2\n\tngramcmp [-c] [-h] -i\n");
		printf("\t-c\tUlozenie n-gramoveho profilu na disk.\n\t\tProfil kazdeho porovnavaneho suboru bude ulozeny na\n\t\tdisk do suboru nazov_porovnavaneho_suboru.ngram-profile.\n\t\tPokial uz takyto profil pre subor existuje, program ho\n\t\tnacita zuvedeneho suboru anepocita ho znovu.\n\t\tUzitocne pri vzajomnom porovnavani vacsieho mnozstva suborov,\n\t\tpredovsetkym vpripade porovnavania jedneho suboru sviacerymi\n\t\troznymi subormi.\n");
		printf("\t-h\tPri vypocte profilu sa pouzije hasovacia tabulka namiesto \n\t\tstandardnch C++ stromov. Podstatne rychlejsia metoda\n\t\tako stromy.\n");
		printf("\tsubor1,\n\tsubor2\tSubory na porovnanie.\n");
		printf("\t-i\tPorovnanie viacerych dvojic suborov. \n\t\tProgram cita standardny vstup. Na kazdom riadku ocakava\n\t\tdvojicu suborov na porovnanie oddelenu medzerou \n\t\talebo tabulatorom. Tento prepinac\n\t\tje uzitocny vkombinacii s -c.\n");
		printf("Poznmky:\tPrepinace mozno uvadzat vlubovolnom poradi, vzdy \n\t\tvsak pred porovnavanymi subormi. Mozno ich uvadzat\n\t\tspolu aj oddelene (-ch alebo -c -h).\n\t\tVzdy sa odporuca pouzit prepinac -h.\n");
		printf("Nvratov hodnoty:\n\t0\tUspesne porovnanie dvojice suborov\n\t\t(bez prepinaca -i). Vpripade pouzitia tohto\n\t\tprepinaca je navratova hodnota vzdy 0.\n\t1\tV pripade porovnania dvojice suborov\n\t\tdoslo kchybe:\n\t\t-aspon jeden zo vstupnych suborov nemozno otvorit\n\t\t-preplnenie buffra tokenizera (napr. vpripade\n\t\t pokusu oporovnanie binarnych suborov)\n\t\t-nespravne pouzitie argumentov prikazoveho riadku\n");

		


		exit (1);
		}

	//ak ideme zo std. vstupu, musime vypocitat vela profilov ....
	while ((ifile==1 && fscanf(stdin,"%s %s",m1,m2)==2) || ifile==-1)
		{
		//ak je cache, skusime profil nahrat
		profile1=profile2=NULL;
		if (cache)
			{
			if (strlen((ifile==1?m1:argv[ff]))>999)
				{
				printf("Prilis dlhy nazov suboru!!!\n");
				exit(1);
				}
			strcpy(buf1,(ifile==1?m1:argv[ff]));
			strcat(buf1,".ngram-profile");
			if ((proffile=fopen(buf1,"r"))!=NULL)
				{ //profil nacitame
				profile1=new map <string, int>;
				while (fscanf(proffile,"%s %d",buf, &i)==2)
					{
					profile1->insert(make_pair(buf,i));
					}
				fclose(proffile);
				}
			if (strlen((ifile==1?m2:argv[sf]))>999)
				{
				printf("Prilis dlhy nazov suboru!!!\n");
				exit(1);
				}
			strcpy(buf2,(ifile==1?m2:argv[sf]));
			strcat(buf2,".ngram-profile");
			if ((proffile=fopen(buf2,"r"))!=NULL)
				{ //profil nacitame
				profile2=new map <string, int>;
				while (fscanf(proffile,"%s %d",buf, &i)==2)
					{
					profile2->insert(make_pair(buf,i));
					}
				fclose(proffile);
				}
			}

		if (profile1==NULL)
			{
			if (!tok.Init((ifile==1?m1:argv[ff])))
				{
				printf ("%s sa neda otvorit\n", (ifile==1?m1:argv[ff]));
				if (ifile==1)
					continue;
				else
					exit(1);
				}

			if (hash)
				m=nga.AnalyzeWHash(&tok);
			else
				m=nga.Analyze(&tok);

			if (m!=NULL)
				{
				if (verb)
					printf("Pocet n-gramov:%d\n",m->size());
				}
			else
				{
				printf("CHYBA:%s\n",nga.GetLastError());
				if (ifile==1)
					continue;
				else
					exit(1);
				}
			n=nga.Srt(m);
			profile1=nga.CreateProfile(n,500);

			if (cache && (proffile=fopen(buf1,"w"))!=NULL)
				{
				for (i1=profile1->begin(),i2=profile1->end();i1!=i2;i1++)
					fprintf(proffile,"%s %d\n",i1->first.c_str(), i1->second);
				fclose(proffile);
				}
			delete m;
			delete n;
			}

		if (profile2==NULL)
			{
			if (!tok.Init((ifile==1?m2:argv[sf])))
				{
				printf ("%s sa neda otvorit\n", (ifile==1?m2:argv[sf]));
				if (ifile==1)
					continue;
				else
					exit(1);
				}

			if (hash)
				m=nga.AnalyzeWHash(&tok);
			else
				m=nga.Analyze(&tok);

			if (m!=NULL)
				{
				if (verb)
					printf("Pocet n-gramov:%d\n",m->size());
				}
			else
				{
				printf("CHYBA:%s\n",nga.GetLastError());
				if (ifile==1)
					continue;
				else
					exit(1);
				}
			n=nga.Srt(m);
			profile2=nga.CreateProfile(n,500);
			if (cache && (proffile=fopen(buf2,"w"))!=NULL)
				{
				for (i1=profile2->begin(),i2=profile2->end();i1!=i2;i1++)
					fprintf(proffile,"%s %d\n",i1->first.c_str(), i1->second);
				fclose(proffile);
				}

			delete m;
			delete n;
			}

		dst=nga.ProfileDistance(profile1,profile2,&sim);
		if (verb)
			{
			printf("%s\t%s\n",argv[ff],argv[sf]);
			printf("Vzd:%lf, Pod:%lf%%\n",dst,sim);
			}
		else
			printf("%lf\n",sim);
		delete profile1;
		delete profile2;
		if (ifile==-1)
			ifile=0;
		}
	exit(0);
	}
