#include "fatlib.h"
#include "EFATFS.h"
#include "LogSystem.h"
#include <deque>
#include <iostream>
#include <string>

//generuje unik. mah. c., pouzit max. 100 krat
int UniqRandom(int l)
{
static int mem[100];
static bool init=false;
static int indx=0;
int i,k;
bool u=false;

if (indx>=100)
	{
	u=false;
	indx=0;
	}
if (!init)
	{
	for (i=0;i<100;i++)
		mem[i]=-1;
	init=true;
	}
while (!u)
	{
	k=random(l);
	u=true;
	for (i=0;i<100;i++)
		if (k==mem[i])
			u=false;
	}
mem[indx++]=k;
return k;
}

using namespace std;
main(int argc, char **argv)
{
ExtendedFATFileSystem efs;
deque<string> templates, fnames, gdirs, gfiles, used_fnames;
deque<FileTemplDesc> EFSResult;
deque<int> gattrs;
deque<DirDescr> wholefs;
string s,s1;
LogSystem log;
int i,j,k,l,m,po[3];
FILE *f1,*f2, *f3;
char sss[500];
int r_time=60;
bool chrt=false;
char rparams[500]="";

if ((f1=fopen("time_cfg","r"))!=NULL)
	{
	fscanf(f1,"%d %s",&r_time,sss);
	if (!fgets(rparams,500,f1)) //ine pomocne parametre pre runner
		rparams[0]='\0';
	else
		rparams[strlen(rparams)-1]='\0';
	fclose(f1);
	if (strcmp(sss,"chroot")==0)
		chrt=true;
	}

log.InitLog("EFSprep_log.html",LTHTML,"Priprava pracovneho EFS");
log.LineToLog();
log.LineToLog("Zapis suborov z realneho FS do emulovaneho - FAT12, kratke nazvy",LnTStd,"","+1");
if (!efs.CreateEmptyFileSystem("FATwork.f12",15000000,FAT12,8))
	{
	log.LineToLog("Vytvorenie prazdneho EFS: FAILED",LnTStd,"FF0000");
	exit(1);
	}
log.LineToLog("Vytvorenie prazdneho EFS: OK",LnTStd,"00EE00");
system("mkdir temp");

efs.GenerateShortFileNameTemplates(&templates,10);
efs.GenerateFNamesFromTmplts(&fnames,&templates,5,10,4);

log.LineToLog();
log.LineToLog("Sablony mien a vygenerovane mena suborov pouzite na naplnenie pracovneho EFS:",LnTStd,"","+1");
for (i=0,j=0;i<templates.size();i++)
	{
	log.LineToLog(templates[i],LnTPRE,"FUCHSIA");
	while (fnames[j]!="")
		{
		log.LineToLog(fnames[j],LnTPRE);
		j++;
		}
	j++;
	log.LineToLog();
	}

efs.GenerateRandomFiles("temp/",&fnames,0,100000);
efs.CreateRandomEFSStructure(&EFSResult, &gdirs, &gfiles, &gattrs, &templates, &fnames, 20, 75, 90, 20, 20, 20, 50, true);
if (!efs.Init("FATwork.f12",FAT12,true))
	exit(1);
efs.FillEFS("temp",&gfiles,&fnames,&gdirs,&gattrs, false, true);
system("rm -r -f temp");
log.LineToLog();
efs.GetAllEFSDirs(&wholefs);
log.LineToLog("Obsah pracovneho EFS:",LnTStd,"","+1");
log.EFSContentToLog(&wholefs);
efs.Close();

log.LineToLog();
log.LineToLog();
log.LineToLog("Planovane spustenie zadania:",LnTStd,"","+1");


//treba zabezpecit, aby ani jeden subor z RFS nebol v EFS a naopak
//priprava suborov v realnom FS na zapis do emul. FS
used_fnames=fnames;

l=0;
do
	{
	efs.GenerateShortFileNameTemplates(&templates,10);
	efs.GenerateFNamesFromTmplts(&fnames,&templates,2,10,4);
	l=0;
	for (i=0;i<used_fnames.size() && !l;i++)
		{
		s=used_fnames[i];
		if (s.size()==0)
			continue;
		for (j=0;j<fnames.size() && !l;j++)
			{
			s1=fnames[j];
			if (s1.size()==0)
				continue;
			if (s==s1)
				l=1;
			}
		}
	}
while (l);

system("mkdir work");
efs.GenerateRandomFiles("work/",&fnames,0,100000);
system("cp -r work work_z");

//vyberieme 3 sablony a subory k nim zodp. a zapiseme ich do suboru _to_check, takisto musime vytvorit subor _to_check_2, ktory obsahuje subory, ktore sa z worku nesmu dostat do EFS
f1=fopen("_to_check","w");
f2=fopen("_to_run","w");
f3=fopen("_to_check_2","w");
fprintf(f2,"#!/bin/bash\n");
fprintf(f2,"spcb=`du -s -b | tr -d \"[:blank:]|.\"`\n");
randomize();
used_fnames.clear();
for (i=0;i<3;i++)
	{
	j=UniqRandom(templates.size());
	po[i]=j;
	s=gdirs[random(gdirs.size())];
	s1=s;
	//musime nahradit spatne lom. norm.
	while ((l=s1.find("\\"))!=s1.npos)
		s1[l]='/';

	if (!chrt)
		{
		fprintf(f2,"%srunner -r zadanie_%d.out zadanie_%d.err %s %d zadanie FATwork.f12 \"work/%s\" %s\n",argc>1?argv[1]:"",i,i,rparams,r_time,templates[j].c_str(),s1.c_str());
		fprintf(f2,"spc=`du -s -b | tr -d \"[:blank:]|.\"`\n");
		}
	else
		{
		fprintf(f2,"sudo /usr/sbin/chroot `pwd` %srunner -r zadanie_%d.out zadanie_%d.err %s %d zadanie FATwork.f12 \"work/%s\" %s\n",argc>1?argv[1]:"",i,i,rparams,r_time,templates[j].c_str(),s1.c_str());
		fprintf(f2,"spc=`sudo /usr/sbin/chroot \\`pwd\\` du -s -b | tr -d \"[:blank:]|.\"`\n");
		}
	fprintf(f2,"if (($spc - $spcb > 10000000))\n");
	fprintf(f2,"\tthen\n");
    	fprintf(f2,"\texit 1\n");
	fprintf(f2,"fi\n");
	log.LineToLog(string("zadanie FATwork.f12 \"work/")+templates[j]+string("\" ")+s1,LnTPRE);
	sprintf(sss,"Presmerovanie vystupu:zadanie_%d.out\nPresmerovanie chyboveho vystupu: zadanie_%d.err\n",i,i);
	log.LineToLog(sss,LnTPRE,"FUCHSIA");
	//musime najst zodp. subory
	for (k=0,l=0;k<j;k++)
		{
		while (fnames[l]!="")
			l++;
		l++;
		}
		while (fnames[l]!="")
			{
			fprintf(f1,"%s\\%s\n",s.c_str(),fnames[l].c_str());
			used_fnames.push_back(fnames[l]);
			l++;
			}
	}
fprintf(f2,"exit 0\n");
fclose(f1);
fclose(f2);
//do f3 nagenerujeme vsetky kombinacie nepouzitych suborov a adresarov -- tieto nesmu existovat v EFS
//najprv pre root
for (i=0;i<fnames.size();i++)
	{
	l=0;
	s=fnames[i];
	for (j=0;j<used_fnames.size();j++)
		if (s==used_fnames[j])
			{
			l=1;
			break;
			}
	if (!l && s.size()>0)
	fprintf(f3,"%s\n",s.c_str());
	}
//teraz pre vsetky ostatne adresare v EFS
for (k=0;k<gdirs.size();k++)
	{
	s1=gdirs[k];
	for (i=0;i<fnames.size();i++)
		{
		l=0;
		s=fnames[i];
		for (j=0;j<used_fnames.size();j++)
			if (s==used_fnames[j])
				{
				l=1;
				break;
				}
		if (!l && s.size()>0)
			fprintf(f3,"%s\\%s\n",s1.c_str(),s.c_str());
		}
	}
fclose(f3);
log.CloseLog();
}
