#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sys/wait.h>
#include <signal.h>

main(int argc, char **argv)
{
pid_t chp;
int status, redir=0, i=2,j, reqargs=3, r1, r2; //i ukazuje na nazov programu v poli parametrov
char * params[100]; //pole smernikov na parametre, max. 100
time_t t1;
FILE *f;
int maxtime,killed=0, ch_status=0;
rlim_t tlim=0, mlim=0, flim=0;
struct rlimit srlim;

//musia sa zadat aspon dva argumenty - program a max. cas behu
if (argc<3 || argc>100)
	{
	printf("runner verzia 2.0 - tento program spusti lubovolny iny program,\n");
	printf("ale nedovoli mu bezat dlhsie, nez specifikovany cas (pouzije kill)\n");
	printf("SYNTAX: \nrunner [-r vystup ch_vystup] [-m mlimit] [-f flimit] [-t tlimit]\n\tcas program [par1 par2 ... parn]\n");
	printf("cas          - maximalny cas behu spusteneho programu v sekundach\n");
	printf("program      - spustitelny subor, ktory bude spusteny\n");
	printf("par1...parn  - parametre, ktore budu predane spustanemu programu(max. 100)\n");
	printf("vystup       - meno suboru na presmerovanie std. vystupu spusteneho programu\n");
	printf("ch_vystup    - meno suboru na presmerovanie chyb. vystupu spusteneho programu\n");
	printf("-r           - pouzit presmerovanie vystupu spusteneho programu\n");
	printf("-m           - nastavit obmedzenie adres. priestoru \n\tspusteneho programu na mlimit bajtov\n");
	printf("-f           - nastavit obmedzenie pre velkost suborov \n\tspusteneho programu na flimit bajtov\n");
	printf("-t           - nastavit obmedzenie pre cas procesora \n\tspusteneho programu na tlimit sekund\n\n");
	printf("Navratove hodnoty:\n");
	printf("128 - chyba argumentov\n");
	printf("129 - chyba pri spusteni ciel. programu(neuspech fork/exec)\n");
	printf("130 - cielovy program bezal dlhsie, nez stanovil limit, bol pouzity kill\n");
	printf("131 - cielovy program neskoncil korektne\n");
	printf("132 - chyba pri pokuse o nastavenie limitu\n");
	printf("V pripade uspesneho spustenia a ukoncenia programu sa navratova hodnota zhoduje s navratovou\nhodnotou vratenou cielovym programom.\n");
	exit(128);
	}

for (j=1;j<argc;j++)
	{
	if (strcmp(argv[j],"-r")==0)
		{
		reqargs+=3;
		i+=3;
		redir=1;
		r1=j+1;
		r2=j+2;
		}
	if (strcmp(argv[j],"-m")==0)
		{
		reqargs+=2;
		i+=2;
		mlim=atoi(argv[j+1]);
		}
	if (strcmp(argv[j],"-f")==0)
		{
		reqargs+=2;
		i+=2;
		flim=atoi(argv[j+1]);
		}
	if (strcmp(argv[j],"-t")==0)
		{
		reqargs+=2;
		i+=2;
		tlim=atoi(argv[j+1]);
		}
	}
if (argc<reqargs)
	{
	printf("runner - malo argumentov!\n");
	exit(128);
	}

//nastavenie limitov
if (tlim>0)
	{
	srlim.rlim_cur=srlim.rlim_max=tlim;
	if (setrlimit(RLIMIT_CPU,&srlim)!=0)
		{
		printf("runner: chyba pri nastaveni limitu pre cas procesora!\n");
		exit(132);
		}
	}

if (mlim>0)
	{
	srlim.rlim_cur=srlim.rlim_max=mlim;
	if (setrlimit(RLIMIT_AS,&srlim)!=0)
		{
		printf("runner: chyba pri nastaveni limitu pre adresny priestor!\n");
		exit(132);
		}
	}

if (flim>0)
	{
	srlim.rlim_cur=srlim.rlim_max=flim;
	if (setrlimit(RLIMIT_FSIZE,&srlim)!=0)
		{
		printf("runner: chyba pri nastaveni limitu pre velkost suborov!\n");
		exit(132);
		}
	}

//kopirovanie parametrov
for (j=i;j<argc;j++)
	{
	params[j-i]=argv[j];
	}
params[j-i]=NULL;

printf("----------------------------------------------------\n");
printf("Runner:Spustam:\n");
for (j=0;j<100;j++)
	{
	if (params[j]==NULL)
		{
		printf("\n");
		break;
		}

	printf("%s ",params[j]);
	}
maxtime=atoi(argv[i-1]);
printf("runner: Maximalny cas behu %d sekund\n",maxtime);

switch (chp=fork())
	{
	case -1:
		printf("Runner:fork() error\n");
		break;
	case 0:
		//pokusime sa presmerovat vystup
		if (redir)
			{
			printf("runner:presmerovanie vystupov:\n");
			if ((f=fopen(argv[r1],"w"))==NULL)
				{
				printf("runner:%s nemozno otvorit pre zapis\n",argv[r1]);
				}
			else
				{
				dup2(fileno(f),fileno(stdout));
				//printf("stdout=%s\n",argv[2]);
				}
			if ((f=fopen(argv[r2],"w"))==NULL)
				{
				printf("runner:%s nemozno otvorit pre zapis\n",argv[r2]);
				}
			else
				{
				dup2(fileno(f),fileno(stderr));
				//printf("stderr=%s\n",argv[3]);
				}
			}
		execv(params[0],params);
		printf("runner: chyba exec()\n");
		exit(129);
		break;
	default:
		break;
	}
//waitpid(chp,NULL,0);
t1=time(NULL);
while (!ch_status && !killed)
	{
//	printf("Child still running ....\n");
	sleep(1);
	if (waitpid(chp,&status,WNOHANG)==chp)
		ch_status=1;
	if (time(NULL)-t1>maxtime && !killed && !ch_status)
		{
		printf("Runner:kill\n");
		kill(chp,SIGKILL);
		killed=1;
		}
	}
printf("runner: Skutocny cas behu:%d s\n",time(NULL)-t1);
if (killed)
	{
	i=130;
	}
else
	{
	printf("runner:potomok ukonceny:%s\n",WIFEXITED(status)?"korektne":"nekorektne");
	if (WIFSIGNALED(status))
		printf("runner: Pricinou ukoncenia bol signal %d\n",WTERMSIG(status));
	//pokus o status
	printf("runner:Exit Status:");
	printf("%d\n",i=WEXITSTATUS(status));
	if (!WIFEXITED(status))
		i=131;
	}
printf("runner:vraciam %d\n",i);
exit(i);
}
