#include "tokenizer.h"
#include <ctype.h>

Tokenizer::Tokenizer(void)
	{
	fbp=tbp=fbrs=0;
	inword=false;
	fl=NULL;
	fbs=sizeof(fbuf);
	tbs=sizeof(tbuf);
	}

Tokenizer::~Tokenizer(void)
	{
	if (fl!=NULL)
		fclose(fl);
	}

bool Tokenizer::Init(char *filename)
	{
	if (fl!=NULL)
		fclose(fl);
	fbp=tbp=0;
	fbrs=0;
	inword=false;
	return ((fl=fopen(filename,"r"))!=NULL);
	}

bool Tokenizer::FillBuf(void)
	{
	if (!fl)
		return false;
	fbrs=fread(fbuf,1,fbs,fl);
	fbp=0;
	return (fbrs>0);
	}


int Tokenizer::GetNextToken(void)
	{
	int c;
	bool tready=false;

	tbp=0;
	inword=false;

	while (!tready)
		{
		if (fbp>=fbrs && !FillBuf())
			return 0;
		c=fbuf[fbp++];
		if (!isspace(c))
			{
			inword=true;
			tbuf[tbp++]=toupper(c);
			if (tbp==tbs)
				return -1; //preplneny tok. buffer
			}
		else
			if (inword)
				tready=true;
		}
	tbuf[tbp]='\0';
	return 1;
	}

char * Tokenizer::GetBuffAddr(void)
	{
	return tbuf;
	}
